//-------------------------------------------------------------------
//
//  This code is copyright 2010 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------
//
//         File: games_navigator.js
//  Description:
//       Author: Dmitry V. (dmitry.vergeles@g5e.com)
if (window.localStorage.getItem("xpromo") == null || window.localStorage.getItem("xpromo") == "test")
{
  //window.localStorage.clear();
  var t = document.createElement("script");
  t.src = 'scripts/ls.js';
  document.body.appendChild(t);
}

if (!window.requestAnimationFrame)
{
  window.requestAnimationFrame = ( function() {
    return window.webkitRequestAnimationFrame ||
      window.mozRequestAnimationFrame ||
      window.oRequestAnimationFrame ||
      window.msRequestAnimationFrame ||
      function( /* function FrameRequestCallback */ callback, /* DOMElement Element */ element ) {
        window.setTimeout( callback, 1000 / 60 );
      };
  })();
}

window.onerror = function(message, source, lineno) {
  alert("message:" + message + " source:" + source + " lineno:" + lineno);
  console.log("message:" + message + " source:" + source + " lineno:" + lineno);
  return false;
};
var activeItem = 1;
var timerID    = 1;
var myScroll   = null;
var appendLocale = {};

var mainGames = {"iphone":[],"ipad":[],"mac":[]},
    cntGenre = {"ipad":{'adv': 0, 'st': 0}, "iphone":{'adv': 0, 'st': 0}, "mac":{'adv': 0, 'st': 0}};
/* Variables for PopUp*/
var popupGamesNew   = {"iphone":[],"ipad":[],"mac":[]},
  popupGamesUpdate  = {"iphone":[],"ipad":[],"mac":[]};

var flagToStore = true;
var userAgent = navigator.userAgent.toLowerCase();
var hasScroll = false;
hasScroll |= (userAgent.indexOf("ipad") != -1 || userAgent.indexOf("iphone") != -1) &&
  (userAgent.indexOf("os 3") == -1 && userAgent.indexOf("os 4")   == -1);
hasScroll |= (userAgent.indexOf("trident") != -1);

var isIpadNew = isIpadNewFunc();

var XPROMO_SITE = 'http://xpromo.g5e.com/v1/';
var bannerDir = {"iphone":"news", "ipad":"news.hd", "mac":"news.mac",  "android":"news.android"};
var BANNER_SITE = {"iphone":XPROMO_SITE + "news/", "ipad":XPROMO_SITE + "news.hd/", "mac":XPROMO_SITE + "news.mac/",  "android":XPROMO_SITE + "news.android/"};

var self_id = gamesSelfId();
var index = 1;

var countShowGame = 14;
var dt = new Date().getTime();

var bnArr = {'hrefFirst': '','hrefSecond': '', 'cnt': 0};

var touchEvent = window.navigator.msPointerEnabled ? 'MSPointerDown' : 'touchstart';

var GAMES_NEW_DATE = new Date(dt - 1000 * 60 * 60 * 24 * 42);
var popUp = {el: null, elI: null, listWidth: 800, cntList: 1, flag: true, scroll: null};
var rateZoom = window.innerHeight / 768;

var
  typeGame          = {},
  dataGallery       = {},
  CoverFlowShablon  = "",
  PopUpShablon      = "",
  BannersShablon    = "",
  platform          = "",
  //GameBoxShablon    = "",
  firstStart        = {"ipad":true,"iphone":true,"mac":true};

for (var id in xpromoGames)
{
  try
  {
    var game  = xpromoGames[id];
    game.id   = id;
    game.date = new Date(game.date);
    if (game.date > GAMES_NEW_DATE)
      game.kind = "new";
    if (!("doomed" in game))
      game.doomed = 0;
  }
  catch (e)
  {
    delete xpromoGames[id];
  }
}

var locale = lockitRender();

$(window).resize(function(){
  updateLayout();
});

$(document).ready(function(){
  platform = window.localStorage.getItem('xpromo.platform');

  if (!platform)
    platform = getPlatformFromId(gamesSelfId());
  platform = platform.toLowerCase();

  $('#games_iphone, #games_ipad, #games_mac').bind(touchEvent + ' mousedown',function(e){
    $("#trace").html("v3 - " + platform + "<br/>");
    if (firstStart[$(this).attr('data-platform')])
    {
      $('.ipad, .iphone, .mac').hide();
      platform = $(this).attr('data-platform');
      $('.' + platform).show();

      /* Create a carusel*/
      _tryLoading();

      firstStart[platform] = false;
      /* Create a PopUp*/
      $('#popup').html(PopUpShablon);
      if ( popupGamesNew[platform].length > 0 || popupGamesUpdate[platform].length > 0 )
      {
        renderPopUpGame(popupGamesNew[platform].concat(popupGamesUpdate[platform]));
        popupGamesNew[platform].length = 0;
        popupGamesUpdate[platform].length = 0;
      }
      setScroll();
      scrollGame();
      $('.' + platform + ' .games-box ul li[data-id]').each(function(){
        loadLi($(this), true);
      });

      renderGames(platform);

      activeItem = 1;
      setTimeout(bannersFetch(platform), 4000);

      if(isIpadNew && platform == "ipad")
      {
        setTimeout(preloadBigImage(), 4000);
      }
    }
    if(platform == $(this).attr('data-platform'))
    {
      setTimeout(function(){$('#platform').hide();}, 200);
      return false;
    }

    $('.' + platform).hide();
    platform = $(this).attr('data-platform');

    /* Create a carusel*/
    _tryLoading();

    $('.' + platform).show();

    clearTimeout(timerID);
    $(".select-type a").removeClass('selected');
    $(".popular").addClass("selected");

    $('.' + platform + ' .banner-item').removeClass("transition5s").css({'left':'100%'});

    $('.' + platform + ' .games-box ul').html($('.' + platform + ' .games-box-hidden ul.pplr').html());
    $('#banner-item-' + platform + '-1').css({'left':'0px'});
    $('#banner-item-' + platform + '-2').css({'left':'50%'});

    $("." + platform + " .games-box").css("overflow-x", "hidden");
    $("." + platform + " .games-box").scrollLeft('0');
    $("." + platform + " .games-box").css("overflow-x", "scroll");

    /* Create a PopUp*/
    $('#popup').html(PopUpShablon);
    if ( popupGamesNew[platform].length > 0 || popupGamesUpdate[platform].length > 0 )
    {
      renderPopUpGame(popupGamesNew[platform].concat(popupGamesUpdate[platform]));
      popupGamesNew[platform].length = 0;
      popupGamesUpdate[platform].length = 0;
    }

    window.localStorage.setItem('xpromo.ui.platform', platform);
    setScroll();
    scrollGame();
    setTimeout(function(){$('#platform').hide();}, 200);

    activeItem = 1;
    clearTimeout(timerID);
    timerID = setTimeout(function(){
      scrollerFooterBanner();
    }, 7500);

    return false;
  });

  if (platform == 'android')
  {
    $(".btnExit").hide();
    $('#platform').hide();
    $('.template').hide();

    window.localStorage.setItem('xpromo.ui.platform', platform);

    window.addEventListener("popstate", function(e) {
      if(window.location.hash == "")
        window.location.href = "@exit";
    }, false);
  }

  CoverFlowShablon = $('.carousel').html();
  BannersShablon = $('.banners-box').html();
  PopUpShablon = $('#popup').html();
  updateLayout();

  var getFromUrl = window.localStorage.getItem('xpromo.ui.platform');
  if (getFromUrl)
  {
    platform = getFromUrl;
    if (platform == 'android')
      $('#platform').hide();
    else
    {
      $('#platform').show();
    }
  }
  else
  {
    $('#platform').show();
  }
  listRender();

  $('.header div').on(touchEvent, 'img', function(event){
    window.location.href = "@ext(http://www.g5e.com/)";
  }).on('mousedown', 'img', function(event){
    window.location.href = "@ext(http://www.g5e.com/)";
  });

  $('.btnExit').bind(touchEvent + ' mousedown', function(e){
    $('#platform').show();
  });
});

var CoverFlowDirective  =
{
  "a" : {
    "game<-games" :
    {
      "img@src"  : function(arg) {
        var link = arg.item.id
        switch(platform)
        {
          case "ipad":
            break;
          case "iphone":
            link += ".hd";
            break;
          case "mac":
            link = arg.item.id.replace('.mac', '.hd');
            break;
          default :
            break;
        }
        return XPROMO_SITE + link + "/home_cf.jpg";
      },
      "img@onload"  : function(arg) {
        return "loadBanner(this, false, " + arg.pos + ")";
      },
      "img@onerror"  : function(arg) {
        return "loadBanner(this, true, " + arg.pos + ")";
      },
      "@href"  : function(arg) {
        return arg.item.href;
      },
      "img@data-id" : "game.id"
    }
  }
};

var gamesDirectiveEmpty =
{
  "li" :
  {
    "game<-games" :
    {
      "@data-id" : "game.id",
      ".icon@style" : function(arg) {
        if (arg.pos > countShowGame)
          return iconStyleFor(arg.item.id, 3);
        return 'background-image:url(' + arg.item.id + "/" + iconNameFor(arg.item.id) + ');' + iconStyleFor(arg.item.id, 3);
      },
      ".icon@alt_img" : function(arg) {
        if(isIpadNew)
          return arg.item.id;
        return '';
      }
    }
  }
};

var gamesDirective =
{
  "li" :
  {
    "game<-games" :
    {
      "a@href"      : "game.href",
      ".name"       : "game.name_short",
      ".icon@style" : function(arg) {
        return 'background-image:url(' + arg.item.id + "/" + iconNameFor(arg.item.id) + ');' + iconStyleFor(arg.item.id, 3);
      },
      ".icon@alt_img" : function(arg) {
        if(isIpadNew)
          return arg.item.id;
        return '';
      }
    }
  }
};

/*
 * functions for processing an array of games
 */

function gamesLoadGame(_table, _id)
{
  //TODO: check this code laters
  var lockit = lockitLoad(_id + "/index");
  if (!lockit)
  {
    console.log("not found: " + _id);
    return null;
  }
  var game = _table[_id];
  if (!game)
  {
    game = {};
    game.id = _id;
  }
  var bundle = game.id.split('.').slice(0, 3).join('.');
  game.name       = lockit["title_GN"] || lockit["title"];
  game.name_short = lockit["title_short"] || game.name;
  game.links      = lockit["#links"];
  //game.genre      = lockit["genre"].toLowerCase();
  game.genre      = 'adv';
  if (typeof xpromoGenre == 'object')
  {
    if (typeof xpromoGenre[bundle] != 'undefined')
      game.genre = xpromoGenre[bundle].toLowerCase();
  }
  game.slogan     = lockit["#slogan"] || ""; //add for new GF
  if (!_table[_id])
    _table[_id] = game;
  if (lockit['target_lang'])
  {
    var target_lang = lockit['target_lang'];
    target_lang = target_lang.toLowerCase();
    target_lang = target_lang.split('|');
    if (target_lang.indexOf(lockit['lang'].toLowerCase()) == -1)
      return null;
    var country_lang = window.localStorage.getItem('country_lang');
    if (country_lang != null)
    {
      country_lang = country_lang.toLowerCase();
      country_lang = country_lang.split('|');
      var flag = false;
      for (var b in target_lang)
      {
        if (country_lang.indexOf(target_lang[b]) != -1)
        {
          flag = true;
          break;
        }
      }
      if (!flag)
        return null;
    }
    else
    {
      return null;
    }
  }
  return game;
}

/*
* function for a listing of games
* */
function listRender()
{
  if (platform == 'ipad' || platform == 'iphone' || platform == 'mac')
  {
    var latest_games = $('.latest-games').clone(true).addClass('ipad');
    $('.latest-games').addClass('iphone');
    latest_games.insertAfter('.latest-games.iphone');
    latest_games = latest_games.clone(true).removeClass('ipad').addClass('mac');
    latest_games.insertAfter('.latest-games.ipad');

    var banners_box = $('.banners-box').clone(true).addClass('ipad');
    $('.banners-box').addClass('iphone');
    banners_box.insertAfter('.banners-box.iphone');
    banners_box = banners_box.clone(true).removeClass('ipad').addClass('mac');
    banners_box.insertAfter('.banners-box.ipad');
    $('.' + platform).show();
    bnArr = {'ipad':{'hrefFirst': '','hrefSecond': '', 'cnt': 0},
      'iphone':{'hrefFirst': '','hrefSecond': '', 'cnt': 0},
      'mac':{'hrefFirst': '','hrefSecond': '', 'cnt': 0}
    };

  }
  else
  {
    $('.latest-games').addClass('android');
    bnArr ={'android':{'hrefFirst': '','hrefSecond': '', 'cnt': 0}};
  }

  updateLayout();

  var tmp = null,
    arr = {}, i, bundle;
  var cnt = parseInt(window.localStorage.getItem("xpromo.games.count"));

  if (isNaN(cnt))
    cnt = 0;
  /* Variables for PopUp*/
  var last_visit        = window.localStorage.getItem('xpromo.ui.lastvisit'),
    popupGamesCount   = {'ipad':0, 'iphone':0, 'mac':0};

  try{
    last_visit = JSON.parse(last_visit) || {};
  }catch(e) {
    last_visit = {};
  }

  for (i in popupGamesCount)
  {
    if (last_visit == null || last_visit[i] == null || last_visit[i] == "")
      last_visit[i] = new Date(0);
    else
      last_visit[i] = new Date(last_visit[i]);
  }

  for(i = 0; i < cnt; i++)
  {
    tmp = window.localStorage.getItem("xpromo.games." + i + ".id");
    var temp_platform = getPlatformFromId(tmp);
    if (tmp != null && typeof xpromoGames[tmp] != 'undefined' && tmp != self_id)
    {
      arr = $.extend({}, xpromoGames[tmp]);
      arr.id = tmp;
      if (typeof xpromoGenre == 'object')
      {
        arr.genre = 'adv';
        bundle = tmp.split('.').slice(0, 3).join('.');
        if (typeof xpromoGenre[bundle] != 'undefined')
          arr.genre = xpromoGenre[bundle].toLowerCase();
        if (['adv', 'both'].indexOf(arr.genre) != -1)
          cntGenre[temp_platform]['adv']++;
        if (['st', 'both'].indexOf(arr.genre) != -1)
          cntGenre[temp_platform]['st']++;
      }
      mainGames[temp_platform].push(arr);
      /* Array for PopUp*/
      if (popupGamesCount[temp_platform] < 8)
      {
        if (xpromoGames[tmp].date > last_visit[temp_platform] && xpromoGames[tmp].date <  new Date())
        {
          arr = gamesLoadGame(xpromoGames, tmp);
          arr.href = getLink(arr);
          popupGamesNew[temp_platform].push(arr);
          popupGamesCount[temp_platform]++;
        }
        else
        if (typeof xpromoGames[tmp].update != 'undefined' && new Date(xpromoGames[tmp].update) > last_visit[temp_platform] && new Date(xpromoGames[tmp].update) <  new Date())
        {
          arr = gamesLoadGame(xpromoGames, tmp);
          arr.href = getLink(arr);
          popupGamesUpdate[platform].push(arr);

          popupGamesCount[temp_platform]++;
        }
      }
    }
  }

  for (_platform in mainGames)
  {
//    mainGames[_platform] = mainGames[_platform].slice(0, 14);
    $("." + _platform + " .games-box-hidden").eq(0).html($('#gt').html());
    cntGenre[_platform]['global'] = cntGenre[_platform]['adv'] + cntGenre[_platform]['st'];
    if (cntGenre[_platform]['global'] > 0)
    {
      if (cntGenre[_platform]['st'] > 0)
        $("." + _platform + " .select-type .strategy span").append(' (' + cntGenre[_platform]['st'] + ')');
      if (cntGenre[_platform]['adv'] > 0)
        $("." + _platform + " .select-type .adventure span").append(' (' + cntGenre[_platform]['adv'] + ')');
      $("." + _platform + " .select-type .popular span, ." + _platform + " .select-type .recent span").append(' (' + cntGenre[_platform]['global'] + ')');
    }
    var gamesBox = $p("." + _platform + " .games-box ul");
    $('.' + _platform + ' .select-type a').eq(1).addClass('selected');
    var data = {'games': replaceSort(mainGames[_platform], false)};
    countShowGame = Math.ceil(($('.games-box').width() + 1500) / 144);
    gamesBox.autoRender(data, gamesDirectiveEmpty);
    var el = $('.' + _platform + ' .games-box ul li');
    var mx = Math.min(el.length, countShowGame);
    for(i = 0; i < mx; i++)
      loadLi(el.eq(i));

    setTimeout(bannerFirstRender(_platform), 0);
  }
}

function loadLi(_el, _flag) {
  _flag = !!_flag;
  var id = _el.attr('data-id');
  if (typeof appendLocale[id] == 'undefined')
  {
    appendLocale[id] = gamesLoadGame(xpromoGames, id);
    appendLocale[id].href = getLink(appendLocale[id]);
  }
  if (!appendLocale[id].href)
  {
    _el.remove();
  }
  else
  {
    if (_flag)
      _el.find('.icon').css('background-image','url(' + id + "/" + iconNameFor(id) + ')');
    _el.find('.name').html(appendLocale[id].name_short);
    _el.find('a').attr('href', appendLocale[id].href);
    _el.removeAttr('data-id');
  }
}

function setScroll() {
  /* iPad 7_0_2 bug? correct width for iPhone version game running on the iPad(LFNII-970)   */
  if (userAgent.indexOf("7_0_2") != -1 && userAgent.indexOf("ipad") != -1 && platform == "iphone")
  {
    $('.main').width(window.innerWidth / (window.innerHeight / 768) + "px");
  }

  if (!hasScroll)
  {
    $("." + platform + " .games-box").css("overflow-x", "hidden");
    var mouseWheel = false;
    if (userAgent.indexOf("mac") != -1)
      mouseWheel = true;
    myScroll = new IScroll($p("." + platform + " .games-box")[0], {
      scrollX:true,
      scrollY:false,
      mouseWheel: mouseWheel,
      tap: false,
      click: true
    });
    myScroll.on('scrollEnd', function () {
      flagToStore = true;
    });

    $("." + platform + ' .games-box').on('click', 'a', function(){
      if (flagToStore)
      {
        flagToStore = false;
        setTimeout(function(){flagToStore = true;}, 1000);
        return true;
      }
      else
      {
        return false;
      }
    });
    if (myScroll.maxScrollX < 0)
    {
      var maxScroll = Math.max(myScroll.maxScrollX, -1500);
      myScroll.scrollTo(maxScroll, 0, 0);
    }
  }
  else
  {
    $(".games-box").css("overflow-x", "scroll");
    var gameBox    = $("." + platform + ' .games-box');
    var gamesBoxUl = gameBox.find('ul');
    var start      = (gamesBoxUl.width() - gameBox.width());
    start = Math.min(start, 1000);
    if (start > 0)
    {
      $("." + platform + " .games-box ul").css({
        'transform' : 'translate3d(-' + start + 'px, 0px, 0px)',
        '-webkit-transform' : 'translate3d(-' + start + 'px, 0px, 0px)',
        'transition' : 'transform 0s linear',
        '-webkit-transition' : '-webkit-transform 0s linear'
      });
    }
  }
}

function scrollGame() {
//  setTimeout(bannerFirstRender, 0);
  setTimeout(function(){
    if (myScroll)
    {
      myScroll.scrollTo(0, 0, 4000);
    }
    else
    {
      $(".games-box ul").css({
        'transform': 'translate3d(0px, 0px, 0px)',
        '-webkit-transform': 'translate3d(0px, 0px, 0px)',
        'transition': 'transform 3s ease',
        '-webkit-transition': '-webkit-transform 3s ease'
      });
    }
    setTimeout(function(){
      if (!myScroll)
      {
        $("." + platform + ' .games-box').css({
          'overflow-scrolling': 'touch',
          '-webkit-overflow-scrolling': 'touch'
        }).find('ul').css({
            'transform': 'translate3d(0px, 0px, 0px)',
            '-webkit-transform': 'translate3d(0px, 0px, 0px)',
            'transition': 'transform 0s ease',
            '-webkit-transition': '-webkit-transform 0s ease'
          });
      }
    }, 4000);
  }, 500);
}

function renderGames(_platform) {
  var data = {}, i;
  var id;
  _platform = _platform || platform;
  for (i in mainGames[_platform])
  {
    id = mainGames[_platform][i].id;
    if (typeof appendLocale[id] == 'undefined')
    {
      appendLocale[id] = gamesLoadGame(xpromoGames, id);
      appendLocale[id].href = getLink(appendLocale[id]);
    }
    mainGames[_platform][i] = $.extend({}, appendLocale[id]);
  }
  mainGames[_platform] = mainGames[_platform].filter(function(element){
    return (!!element.href);
  });
  var gamesBox;
  var arr = {'rcnt': true, 'pplr': false};
  for (i in arr)
  {
    gamesBox = $p('.' + _platform + ' .games-box-hidden ul.' + i);
    data.games = mainGames[_platform].slice(0);
    data.games = replaceSort(data.games, arr[i]);
    gamesBox.autoRender(data, gamesDirective);
  }
  arr = {'st': 'strategy', 'adv': 'adventure'};
  mainGames[_platform] = replaceSort(mainGames[_platform], true);
  for (i in arr)
  {
    data.games = mainGames[_platform].filter(function(element)
    {
      if(element.genre == i || element.genre == 'both')
        return true;
      return false;
    });
    gamesBox = $p('.' + _platform + ' .games-box-hidden ul.' + i);
    gamesBox.autoRender(data, gamesDirective);
  }
  $('.' + _platform + ' .select-type').on(touchEvent, 'a', changeType).on('mousedown', 'a', changeType);
}

function getLink(_locale) {
  var ret = false;
  if (!_locale.links)
    return false;
  var arr = ['download', 'free', 'lite', 'full', 'temp'];
  for (var i in arr)
  {
    if(arr[i] in _locale.links)
    {
      if (arr[i] == 'temp')
      {
        if (mainGames.length <= 5)
        {
          ret = _locale.links[arr[i]];
          break;
        }
      }
      else
      if (_locale.date.getTime() < dt)
      {
        ret = _locale.links[arr[i]];
        break;
      }
    }
  }
  if (typeof ret == 'string')
  {
    if (ret.indexOf('javascript:') == -1)
    {
      if ('hastrk3LP' in _locale.links && _locale.links.hastrk3LP != '')
      {
        ret = convertLink("@ext(" + _locale.links.hastrk3LP + ")", "", "&sub_campaign=LP%20Upsell");
      }
      else
      {
        ret = convertLink("@ext(" + ret + ")", _locale.links.hastrk3, "&sub_campaign=LP%20Upsell");
      }
    }
  }
  return ret;
}

function replaceSort(arr, flag)
{
  var arr_doomed, arr_middle, arr_top;
  arr_doomed = arr.filter(function(element, index, array)
  {
    return (element.doomed < 0);
  });
  if (flag)
  {
    arr_doomed.sort(function(a, b)
    {
      return b.date - a.date;
    });
  }
  if (flag)
  {
    arr_middle = arr.filter(function(element, index, array)
    {
      return (element.doomed == 0);
    });
    arr_middle.sort(function(a, b)
    {
      return b.date - a.date;
    });
    arr_top = arr.filter(function(element, index, array)
    {
      return (element.doomed > 0);
    });
    arr_top.sort(function(a, b)
    {
      if (a.doomed == b.doomed)
        return b.date - a.date;
      return a.doomed - b.doomed;
    });
    var ret = new Array();
    var i;
    for (var b in arr_top)
    {
      i = arr_top[b].doomed - 1;
      while(ret[i] != undefined)
        i++;
      ret[i] = arr_top[b];
    }
    i = 0;
    for (var b in arr_middle)
    {
      while(ret[i] != undefined)
        i++;
      ret[i] = arr_middle[b];
    }
    for (var b in arr_doomed)
    {
      while(ret[i] != undefined)
        i++;
      ret[i] = arr_doomed[b];
    }
  }
  else
  {
    arr_middle = arr.filter(function(element, index, array)
    {
      return (element.doomed > -1);
    });
    var ret = arr_middle.concat(arr_doomed);
  }
  return ret;
}

function changeType(e){
  if($(this).hasClass('selected'))
    return;
  if($("." + platform + " .games-box").scrollLeft() > 0)
    $("." + platform + " .games-box").css("overflow-x", "hidden");
  if (e.type.toLowerCase() != 'mousedown')
  {
    e.preventDefault();
    e.stopPropagation();
  }
  var th = $(this);
  var tp = th.attr('data-type');
  if (myScroll)
    myScroll.scrollTo(0, 0, 0.2);
  $('.' + platform + ' .games-box ul').html($('.' + platform + ' .games-box-hidden ul.' + tp).html());
  if (myScroll)
  {
    myScroll.refresh();
    myScroll.scrollTo(0, 0, 0);
  }
  else
  {
    $(".games-box").scrollLeft('0');
  }
  $("." + platform + " .select-type a").removeClass('selected');
  th.addClass('selected');
  $("." + platform + " .games-box").css("overflow-x", "scroll");
};


/*
* Banners, bottom app
*/
function bannersFetch(_platform)
{
  _platform = _platform || platform;

  var bannerRequest = new XMLHttpRequest();
  bannerRequest.open("GET", BANNER_SITE[_platform] + "banners.txt", true);
  bannerRequest.onreadystatechange = function(){
    if (this.readyState != 4)
      return;

    var text;
    if (this.status == 200 || this.responseText) // for local GET to work
    {
      text = this.responseText;
      window.localStorage.setItem("xpromo.banners." + _platform, text);
      getBanners(JSON.parse(text), _platform);
    }
    else
    {
      var t = document.createElement("script");
      t.src = XPROMO_SITE + 'service/get_banners.php?bannerDir=' + bannerDir[_platform] + "&bannerFile=banners.txt&functionName=getBanners&platform=" + _platform;
      t.id = "get_banners_"+_platform;
      t.onerror = function(){
        getBanners(getBannersFromStorage(_platform), _platform);
      };
      document.body.appendChild(t);
    }
  }
  bannerRequest.send(null);
}

function getBannersFromStorage(_platform) {
  var content = window.localStorage.getItem('xpromo.banners.' + _platform);
  if (content != null)
    return JSON.parse(content);
  return lockitLoadLangs(bannerDir[_platform] + '/banners');
}

function getBanners(text, _platform, _flag)
{
  _platform = _platform || platform;
  _flag = !_flag;
  if (_flag)
    window.localStorage.setItem("xpromo.banners." + _platform, JSON.stringify(text));
  var xpromoBanners = null;
  if (text)
    xpromoBanners = lockitGet(text);

  var data = {};
  data.banners = lockitThis.banners;
  if (xpromoBanners)
    data.banners = xpromoBanners.banners.concat(data.banners);

  var timeNow = new Date().getTime();

  data.banners = data.banners.filter(function(element, index, array)
  {
    if (element.begsAt)
    {
      var begsAt = new Date(element.begsAt);
      if (dt < begsAt.getTime())
        return false;
    }

    if (element.endsAt)
    {
      var endsAt = new Date(element.endsAt);
      if (dt >= endsAt.getTime())
        return false;
    }

    if (element.includes)
    {
      var arrIncludes = element.includes.split('|');
      if(!inArray(self_id, arrIncludes))
        return false;
    }

    if (element.excludes)
    {
      var arrExcludes = element.excludes.split('|');
      if(inArray(self_id, arrExcludes) != false)
        return false;
    }

    if(element.hastrk3LP != undefined && element.hastrk3LP != "")
    {
      element.href = convertLink(element.hastrk3LP, "", "&sub_campaign=lp_promo");
    }
    else
    {
      element.href = convertLink(element.href, element.hastrk3, "&sub_campaign=lp_promo");
    }
    element.href = convertLink(element.href);

    return true;
  });
  if (_flag)
    bannersRender(data, _platform);
  //timerID = setTimeout('scrollerByTimeOut()', 7000);
  return data;
  //bannersRender(data);
}

var bannerDirective = {
  "@id" : function(arg) {
    return "banner-item-" + arg.context.platform + "-" + (arg.context.pos + 1);
  },
  "@href" : "href",
  "@data-xpromoid"  : function(arg) {
    if (arg.context.icon)
      return arg.context.icon.split('/')[0];
    else
    if (arg.context.style)
      return arg.context.style.split('/')[1].split('.')[0] + ".png";
    else
      return "else.lp";
  },
  "@style"      : function(arg)
  {
    var result = "";

    switch(arg.context.pos)
    {
      case 0:
        result += "left:0;";
        break;
      case 1:
        result += "left:50%;";
        break;
      default :
        result += "left:100%;";
        break;
    }
    result += "width:50%;";
    if (arg.context.style)
    {
      arg.context.style = arg.context.style.substring(0, arg.context.style.indexOf("theme/")) + "theme/gn_" + arg.context.style.substring(arg.context.style.indexOf("theme/") + 6) + ";background-position-x:0";
      result += arg.context.style;
    }
    return result;
  },
  ".icon@style" : function(arg)
  {
    if (arg.context.icon)
    {
      return "background-image: url('" + arg.context.icon + "');display:inline-block;";
    }

    return "display:none;";
  },
  ".icon@alt_img" : function(arg) {
    if (arg.context.icon && isIpadNew)
    {
      var tmp = arg.context.icon;
      var pos = tmp.indexOf('/');
      if (pos != -1)
        return tmp.substring(0, pos);
    }
    return '';
  },
  ".icon@class" : function(arg)
  {
    if (arg.context.icon)
    {
      var game_id = arg.context.icon;
      game_id = game_id.split('/');
      game_id = game_id[0];
      var platform = getPlatformFromId(game_id);
      var iconNew = "";
      if (xpromoGames[game_id] === undefined)
        return "icon icon_" + platform;
      var date = xpromoGames[game_id].date;
      var now = new Date();
      now.setDate( now.getDate() - 14 );
      if (date > now)
      {
        var lang = window.localStorage.getItem("xpromo.lang")||"en";
        iconNew = " icon_new language_" + lang;
      }
      return "icon icon_" + platform + iconNew;
    }
    return "icon";
  },
  "div.text@style"    : function(arg)
  {
    if (arg.context.icon)
      return "padding: 0px 10px 0px 0px;";
    return "padding: 0px 20px 0px 170px;";
  },
  "div.text"    : "text",
  ".+"          : function(arg)
  {
    return arg.context.button ? ("<div class='button'><span>" + arg.context.button + "</span></div>") : "";
  }
};

function bannerFirstRender (_platform) {
  _platform = _platform || platform;
  bnArr[_platform].bannerBox = $('.banners-box.' + _platform);
  bnArr[_platform].hiddenBox = $('.hidden-box');
  bnArr[_platform].hiddenBox.html(bnArr[_platform].bannerBox.html());
  bnArr[_platform].compiled = bnArr[_platform].hiddenBox.find('.banner-item').compile(bannerDirective);
  var content = '';
  var _data = getBannersFromStorage(_platform);
  if (typeof _data == 'object')
  {
    _data = getBanners(_data, _platform, true);
    if (_data.banners.length > 0)
    {
      _data.banners[0].pos = bnArr[_platform].cnt;
      _data.banners[0].platform = _platform;
      bnArr[_platform].cnt++;
      bnArr[_platform].hrefFirst = _data.banners[0].href;
      _data.banners[1].pos = bnArr[_platform].cnt;
      _data.banners[1].platform = _platform;
      bnArr[_platform].cnt++;
      bnArr[_platform].hrefSecond = _data.banners[1].href;
//      content = bnArr.compiled({_data.banners[0],_data.banners[0]});
      content = bnArr[_platform].compiled(_data.banners[0]);
      content += bnArr[_platform].compiled(_data.banners[1]);
      bnArr[_platform].bannerBox.html(content);
      //fixBanner();
    }
  }
//  setTimeout(bannersFetch(_platform), 4000);
}

function bannersRender(_data, _platform)
{
  _platform = _platform || platform;
  if (bnArr[_platform].cnt == 0)
  {
    bnArr[_platform].bannerBox.html('');
    //fixBanner();
  }
  else
  {
    _data.banners = _data.banners.filter(function (element) {
      if (element.href == bnArr[_platform].hrefFirst || element.href == bnArr[_platform].hrefSecond)
        return false;
      return true;
    });
  }
  var content = '';

  for (var i in _data.banners)
  {
    _data.banners[i].pos = bnArr[_platform].cnt;
    _data.banners[i].platform = _platform;;
    bnArr[_platform].cnt++;
    content = bnArr[_platform].compiled(_data.banners[i]);
    bnArr[_platform].bannerBox.append(content);
  }

  $(".banners-box").on( 'webkitTransitionEnd transitionend OTransitionEnd','a', function( event ) {
    if ($(this).css('left')[0] == "-"){
      $(this).removeClass("transition5s");
      $(this).css("left", "100%");

      clearTimeout(timerID);
      timerID = setTimeout(function(){
        scrollerFooterBanner();
      }, 5500);
    }
  });

  clearTimeout(timerID);
  timerID = setTimeout(function(){
    scrollerFooterBanner();
  }, 7500);

  if (userAgent.indexOf("trident") != -1)
    bannerWin();
}

function scrollerFooterBanner()
{
  if (bnArr[platform].cnt < 3)
  {
    return;
  }

  var aId = ( activeItem >= bnArr[platform].cnt ) ? 1 : activeItem + 1;

  if (activeItem != aId)
  {
    $("#banner-item-" + platform + "-" + ( (aId == 1) ? bnArr[platform].cnt : (aId-1) )).addClass("transition5s");
    $("#banner-item-" + platform + "-" + aId).addClass("transition5s");
    $("#banner-item-" + platform + "-" + ( (aId == bnArr[platform].cnt) ? 1 : (aId+1) )).addClass("transition5s");

    $("#banner-item-" + platform + "-" + ( (aId == 1) ? bnArr[platform].cnt : (aId-1) )).css("left", "-51%");
    $("#banner-item-" + platform + "-" + aId).css("left", "0");
    $("#banner-item-" + platform + "-" + ( (aId == bnArr[platform].cnt) ? 1 : (aId+1) )).css("left", "50%");
    activeItem = aId;
  }
}

/*
* PopUp
* */
function renderPopUpGame(mainGames)
{
  var row2PopUp = {};

  row2PopUp.games = mainGames.slice(0, 8);

  if (row2PopUp.games.length > 0)
  {
    var row1PopUp = {};
    row1PopUp.games = row2PopUp.games.filter(function (element, index, array) {
      return (index % 4) < 2;
    });
    row2PopUp.games = row2PopUp.games.filter(function (element, index, array) {
      return -1 == row1PopUp.games.indexOf(element);
    });
    var popUpDirective = {
      ".game": {
        "game<-games": {
          ".text h2": "game.name",
          ".text span": "game.slogan",
          "div.icon@style": function (arg) {
            return "background-image: url(" + arg.item.id + "/" + iconNameFor(arg.item.id) + ")";
          },
          "div.icon@class+": function (arg) {
            var platform = getPlatformFromId(arg.item.id);
            if (platform == 'mac' || platform == 'android' || platform == 'winrt' || platform == 'winphone')
              return ' icon_' + platform;
            return '';
          },
          "@href": function (arg) {
            var ret = '';
            if (arg.item.links.free != undefined) {
              ret = convertLink('@ext(' + arg.item.links.free + ')');
            }
            else if (arg.item.links.lite != undefined) {
              ret = convertLink('@ext(' + arg.item.links.lite + ')');
            }
            else if (arg.item.links.full != undefined) {
              ret = convertLink('@ext(' + arg.item.links.full + ')');
            }
            else if (arg.item.links.download != undefined) {
              ret = convertLink('@ext(' + arg.item.links.download + ')');
            }
            if (ret == '')
              ret = 'javascript:subscribeExec()';

            return ret;
          }
        }
      }
    };
    popUp.cntList = Math.max(popUp.cntList, Math.ceil(row1PopUp.games.length / 2));
    $p('#popup .row1').autoRender(row1PopUp, popUpDirective);
    $p('#popup .row2').autoRender(row2PopUp, popUpDirective);
    $('#popup').show();
    if (popUp.cntList > 1)
    {
      var gm = $('#popup .list .row1 .game');
      popUp.oneWidth = window.innerWidth * 0.4 / rateZoom;

      popUp.listWidth = (gm.eq(1).offset()['left'] - gm.eq(0).offset()['left']) * 2;
      popUp.el = $('#popup .list');
      popUp.elI = popUp.el.find('.list-inner').eq(0);
      popUp.el.find('a').bind('click', function(){return popUp.flag});
      popUp.elI.css({'width': 'auto', 'position': 'absolute'}).find('a').css('width', popUp.oneWidth);

      if (!hasScroll)
      {
        popUp.scroll =  new IScroll('.list', {
          scrollX: true,
          scrollY: false,
          tap: false,
          click: true,
          useTransition: false,
          horizontalScroll: function(_stage, _startX, _direction, _currentX) {
            switch(_stage)
            {
              case 'move':
                popUp.flag = false;
                break;
              case 'end':
                setTimeout(function(){popUp.flag = true;}, 1000);
                break;
            }
          }
        });

        $('.list').on('click', 'a', function(event){
          if (popUp.flag)
          {
            popUp.flag = false;
            setTimeout(function(){popUp.flag = true;}, 1000);
            return true;
          }
          else
          {
            return false;
          }
        });
      }
      else
      {
        $(".list").css({'overflow-x': 'scroll','overflow-scrolling': 'touch', '-webkit-overflow-scrolling': 'touch'});
        $(".list-inner").css({'overflow': 'hidden'}).height($(".list").height());
      }
    }
  }
}

function closePopup()
{
  var a         = document.getElementById('popup'),
    last_visit  = window.localStorage.getItem('xpromo.ui.lastvisit');

  if (a)
  {
    a.style.display = 'none';
    var checkDate = new Date();
    var dateForWrite = checkDate.getFullYear() + '/';
    if ((checkDate.getMonth() + 1) < 10)
      dateForWrite += '0';
    dateForWrite += (checkDate.getMonth() + 1) + '/';
    if (checkDate.getDate() < 10)
      dateForWrite += '0';
    dateForWrite += checkDate.getDate();

    try{
      last_visit = JSON.parse(last_visit) || {};
    }catch(e) {
      last_visit = {};
    }
    last_visit[platform] = dateForWrite;
    last_visit = JSON.stringify(last_visit);
    window.localStorage.setItem('xpromo.ui.lastvisit', last_visit);
  }
}

/*
* CoverFlow
* */

var _cl = 0,
  _ce = 0,
  _countBannerShow = 4,
  _countBanner = 10;

function _tryLoading()
{
  var tmp = $("#trace").html();
//  $("#trace").html(platform + "<br/>");
//  $('#_loader').hide();
//  $('#_loading').hide();
//  $('#_try_again').hide();
  $('#_loader').show();
  $('#_loading').show();
  $('#_try_again').hide();
  _cl = 0;
  _ce = 0;

  $('.carousel').html(CoverFlowShablon);
  dataGallery.games = mainGames[platform].slice(0, 10);

  for (var b in dataGallery.games)
    dataGallery.games[b].href = getLink(xpromoGames[dataGallery.games[b].id]);

  $p("div.dg-wrapper").autoRender(dataGallery, CoverFlowDirective);
}

function loadBanner(_self, _error, pos)
{
  var tmp = $("#trace").html();
  $("#trace").html(tmp + pos + " - " + _error + " - " + $(_self).attr('src') + "<br/>");
  if (_error)
  {
    if ($(_self).attr('data-id'))
    {
      $(_self).attr('src', XPROMO_SITE + $(_self).attr('data-id') + "/home_cf.jpg");
      $(_self).attr('data-id', "");
      return;
    }
    _ce += 1;
    $(_self.parentNode).remove();
  }
  else
  {
    _cl += 1;
  }
  if ((_cl + _ce) == _countBannerShow){
    // render first img
//    $('#_loader').hide();
//    $('.dg-container').gallery({
//      autoplay	:	false
//    });
  }
  if ((_cl + _ce) == _countBanner)
  {
    if (_cl > 3)
    {
      $('#_loader').hide();
      $('.dg-container').gallery({
        autoplay	:	true
      });
    }
    else
    {
      $('#_loading').hide();
      $('#_try_again').show();
    }
  }
}

/*
 * service functions
 * */
function updateLayout()
{
  rateZoom = window.innerHeight / 768;
  var zoom = rateZoom * 100;
  document.body.style.zoom = zoom + "%";
  if (userAgent.indexOf("trident") != -1)
  {
    zoom = Math.round(zoom) - 1;
    document.body.style.width = 100 * 100 / zoom + "%";
  }
  else
  if (userAgent.indexOf("android 4") == -1)
  {
    document.body.style["font-size"] = document.body.style.zoom;
  }

  if (navigator.userAgent.search(/Firefox/) > -1 || navigator.userAgent.search(/Opera/) > -1)
  {
    $("#cover-flow").css({
      "-moz-transform"    : "scale(" + rateZoom + ")",
      "-o-transform"      : "scale(" + rateZoom + ")",
      "width"             : 100 * 100 / zoom + "%",
      "top"               : (-1)*((1 - (rateZoom))*50) + "%",
      "left"              : ((1 - (100 / zoom))*50) + "%"
    });
  }

  if (myScroll){
    myScroll.refresh();
  }

  $('#popup a').css('width', window.innerWidth * 0.4 / (rateZoom));
}

function preloadBigImage()
{
  if (typeof(window.arr_load) == "undefined")
    window.arr_load = [];
  var tmp;
  //var dt = '?v=' + (new Date().getTime());
  var dt = '?v=1';
  $('.icon').each(function(){
    tmp = $(this).attr('alt_img');
    if(getPlatformFromId(tmp) == 'ipad')
    {
      if(!inArray(tmp, arr_load))
        window.arr_load.push(tmp);
    }
  });
  if(arr_load.length > 0){
    var img = document.createElement('img');
    $(img).bind('load', function() {
      $('div.icon[alt_img="' + arr_load[0] + '"]').removeAttr('alt_img').html('<div style="background-image:url('+ XPROMO_SITE + arr_load[0] + '/icon-big.jpg?' + dt + ')"></div>');
      arr_load.shift();
      if(arr_load[0])
        img.src = XPROMO_SITE + arr_load[0] + '/icon-big.jpg' + dt;
    });
    img.src = XPROMO_SITE + arr_load[0] + '/icon-big.jpg' + dt;
  }

//
//  var arr_load = new Array();
//  var tmp;
//  $('div.latest-games .icon').each(function()
//  {
//    tmp = $(this).attr('alt_img');
//
//    //TODO: sent "undefined" in getPlatformFromId call error
//    if (!tmp)
//      return;
//    if (getPlatformFromId(tmp) == 'ipad')
//    {
//      if (!inArray(tmp, arr_load))
//        arr_load.push(tmp);
//    }
//  });
//  if (arr_load.length > 0)
//  {
//    var img = document.createElement('img');
//    $(img).bind('load', function()
//    {
//      $('div.icon[alt_img="' + arr_load[0] + '"]').css('background-image', 'url(' + XPROMO_SITE + arr_load[0] + '/icon-big.jpg)').removeAttr('alt_img');
//      $('img.icon[alt_img="' + arr_load[0] + '"]').attr('src', XPROMO_SITE + arr_load[0] + '/icon-big.jpg').removeAttr('alt_img');
//      arr_load.shift();
//      if (arr_load[0])
//        img.src = XPROMO_SITE + arr_load[0] + '/icon-big.jpg';
//    });
//    img.src = XPROMO_SITE + arr_load[0] + '/icon-big.jpg';
//  }

}

function gamesSelfId()
{
  var result = window.localStorage.getItem("xpromo.games.self.id");
  if (null == result)
    result = window.localStorage.getItem("xpromo.id");

  return result;
}
