/**
 *
 * -------------------------------------------------------------------
 *
 *  This code is copyright 2010 by G5 Entertainment AB.
 *  Any unauthorized usage, either in part or in whole of this code
 *  is strictly prohibited. Violators WILL be prosecuted to the
 *  maximum extent allowed by law.
 *
 * -------------------------------------------------------------------
 *
 *         File: jquery.banners.js
 *  Description:
 *       Author: Dmitry V. ()
 */

(function( $, undefined ) {
	
  /*
  * Banners object.
  */
  $.Banner 				= function( options, element ) {
    this.$el	= $( element );
    this._init( options );
  };
	
  $.Banner.defaults 		= {
    current         : 0,	// index of current item
    autoplay        : true,// slideshow on / off
    interval        : 9000,  // time between transitions
    gamesDirective  : {
      ".banner-item" :
      {
        "banner<-banners" :
        {
          "@id"         : function(arg) { return "banner-item-" + (arg.pos + 1); },
          "@href"       : "banner.href",
          "@onclick"  : function(arg) {
            if (arg.item.style && arg.item.style.indexOf("let") != -1)
            {
              return "xpromoReport('overlay_tap(button, sign_up)');";
            }
            else
            {
              return "";
            }
          },
          "@style"      : function(arg)
          {
            var result = "";

            //            if (arg.pos != 0)
            //              result += "display:none;";
            if (arg.pos != 0)
              result += "visibility:hidden;";

            if (arg.item.style)
              result += arg.item.style;

            return result;
          },
          ".icon@style" : function(arg)
          {
            if (arg.item.icon)
            {
              var tmp = arg.item.icon;
              var pos = tmp.indexOf('/');
              if(pos != -1)
              {
                tmp = tmp.substring(0, pos);
                return "background-image: url('" + XPROMO_SITE + arg.item.icon + "')" + iconStyleFor(tmp, 3);
              }
            }
            return "display:none;";
          },
          ".icon@alt_img" : function(arg) {
            if (arg.item.icon && isIpadNew){
              var tmp = arg.item.icon;
              var pos = tmp.indexOf('/');
              if(pos != -1)
                return tmp.substring(0, pos);
            }
            return '';
          },
          ".icon@class" : function(arg)
          {
            if (arg.item.icon)
            {
              var game_id = arg.item.icon;
              game_id = game_id.split('/');
              game_id = game_id[0];
              var platform = getPlatformFromId(game_id);
              return "icon icon_" + platform;
            }
            return "icon";
          },
          "div.text"    : "banner.text",
          "@data-img" : function(arg) {
            if (arg.item.style)
            {
              var tmp = arg.item.style;
              var needle = 'url(';
              var pos = tmp.indexOf(needle);
              if (pos > -1)
              {
                tmp = tmp.substr(pos + needle.length);
                pos = tmp.indexOf(')');
                if (pos > -1)
                {
                  tmp = tmp.substr(0, pos);
                  tmp = tmp.replace(/\'/g, '');
                  tmp = tmp.replace(/\"/g, '');
                  tmp = tmp.split('.');
                  tmp[tmp.length - 2] += '_win';
                  return tmp.join('.');
                }
              }
            }
            return '';
          },
          ".+"          : function(arg) { return arg.item.button ? ("<div class='button'><span>" + arg.item.button + "</span></div>") : ""; }

        }
      }
    }
  };

  $.Banner.prototype 	= {
    _init 				: function( options ) {
      // support for 3d / 2d transforms and transitions
      this.support3d		= Modernizr.csstransforms3d;
//      if (navigator.userAgent.toLowerCase().indexOf("android 4.0") != -1)
        this.support3d  = false;
      this.support2d		= Modernizr.csstransforms;
      this.supportTrans	= Modernizr.csstransitions;

      this.options      = $.extend( true, {}, $.Banner.defaults, options );
      this._bannersFetch();
    },

    _bannersFetch :function (){
      var bannerRequest = new XMLHttpRequest();
      var _self2	= this;
      bannerRequest.open("GET", BANNER_SITE + "banners.txt", true);
      bannerRequest.onreadystatechange = function(){
        if (this.readyState != 4)
          return;

        var text;
        if (this.status == 200 || this.responseText) // for local GET to work
        {
          text = this.responseText;
          window.localStorage.setItem("xpromo.banners", text);
          _self2._getBanners(JSON.parse(text));
        }
        else
        {
          var t = document.createElement("script");
          t.src = XPROMO_SITE + 'service/get_banners.php?bannerDir=' + bannerDir + "&bannerFile=banners.txt&functionName=getBanners";
          document.body.appendChild(t);
        }
      }
      bannerRequest.send(null);
    },

    _getBanners :function (text){
      $('.banners-box').css('overflow', 'visible');
      var xpromoBanners = null;
      if (text)
        xpromoBanners = lockitGet(text);
      //xpromoBanners = lockitGet(JSON.parse(text));

      var data = {};
      data.banners = lockitThis.banners;
      if (xpromoBanners)
        data.banners = xpromoBanners.banners.concat(data.banners);

      var timeNow = new Date().getTime();

      data.banners = data.banners.filter(function(element, index, array)
      {
        if (element.begsAt)
        {
          var begsAt = new Date(element.begsAt);
          if (timeNow < begsAt.getTime())
            return false;
        }

        if (element.endsAt)
        {
          var endsAt = new Date(element.endsAt);
          if (timeNow >= endsAt.getTime())
            return false;
        }

        var self_id = gamesSelfId();
        if (element.includes)
        {
          var arrIncludes = element.includes.split('|');
          if(!inArray(self_id, arrIncludes))
            return false;
        }

        if (element.excludes)
        {
          var arrExcludes = element.excludes.split('|');
          if(inArray(self_id, arrExcludes) != false)
            return false;
        }

        if(element.hastrk3LP != undefined && element.hastrk3LP != "")
        {
          element.href = convertLink(element.hastrk3LP, "", "&sub_campaign=LP%20Promo");
        }
        else
        {
          element.href = convertLink(element.href, element.hastrk3, "&sub_campaign=LP%20Promo");
        }

        return true;
      });
      this._bannersRender(data);

    },

    _bannersRender: function (_data){
      $p(".banners-box").autoRender(_data, this.options.gamesDirective);
      if(isIpadNew)
        preloadBigImage();
      var userAgent = navigator.userAgent.toLowerCase();
      if (userAgent.indexOf("trident") != -1)
        this.bannerWin();

      this.$wrapper     = this.$el.find('.banners-box');
      this.$container   = $('.banners-box');

      this.$items       = this.$wrapper.children();
      this.itemsCount   = this.$items.length;
      this._zoom = window.innerHeight / 768;
      // minimum of 3 items
      if( this.itemsCount < 3 )
      {
        return false;
      }
      this.startMove    = false;
      this.Distance     = 0;
      this._translateX  = window.innerWidth / this._zoom;
      this._shift       = 0;
      // переменные для определения скорости и направления скрола
      this.lineMotion   = 'next'; // нужно назначить значение поумолчанию
      this.startX       = 0;
      this._moveTo      = 0;
      this.startTime    = utils.getTime();
      this.current      = this.options.current;
      this.isAnim       = false;
      this.isMove       = false;
      this.pageX        = 0;
      this.$items.css({
        'opacity'	: 0,
        'visibility': 'hidden'
      });

      this._validate();
      this._layout();
      // load the events
      this._loadEvents();
      // slideshow
      if( this.options.autoplay )
      {
        this._startSlideshow();
      }
    },

    bannerWin: function () {
      var allA = $('.banners-box a');
      var arr = [];
      var el;
      for (var i = 0; i < allA.length; i++)
      {
        el = allA.eq(i);
        if (el.attr('data-img'))
          arr.push(el.attr('data-img'));
      }
      if (arr.length > 0)
      {
        function setWinBanner(_name) {
          var image = new Image();
          image.onload = function() {
            allA.filter("[data-img='" + _name + "']").each(function() {
              $(this).css('background-image', 'none').find('div.icon').css('background-image', 'url(' + _name + ')').addClass('icon_mac').show();
            });
          }
          image.src = _name;
        }
        for (var i in arr)
        {
          setWinBanner(arr[i]);
        }
      }
    },
    _validate			: function() {
      if( this.options.current < 0 || this.options.current > this.itemsCount - 1 )
      {
        this.current = 0;
      }
    },

    _layout				: function() {
      // current, left and right items
      this._setItems();
      // current item is not changed
      // left and right one are rotated and translated
      var leftCSS, rightCSS, currentCSS;

      leftCSS 	= {
        '-webkit-transform'	: 'translateX(-'+this._translateX+'px)',
        '-moz-transform'	: 'translateX(-'+this._translateX+'px)',
        '-o-transform'		: 'translateX(-'+this._translateX+'px)',
        '-ms-transform'		: 'translateX(-'+this._translateX+'px)',
        'transform'			: 'translateX(-'+this._translateX+'px)',
        'opacity'     : 1,
        'visibility'  : 'visible'
      };

      rightCSS	= {
        '-webkit-transform'	: 'translateX('+this._translateX+'px)',
        '-moz-transform'	: 'translateX('+this._translateX+'px)',
        '-o-transform'		: 'translateX('+this._translateX+'px)',
        '-ms-transform'		: 'translateX('+this._translateX+'px)',
        'transform'			: 'translateX('+this._translateX+'px)',
        'opacity'     : 1,
        'visibility'  : 'visible'
      };

      currentCSS	= {
        'opacity'     : 1,
        'visibility'  : 'visible'
      };

      this.$leftItm.css( leftCSS || {} );
      this.$rightItm.css( rightCSS || {} );
      this.$currentItm.css( currentCSS || {} ).addClass('dg-center');

      /*create bubles*/
      var bubles = "<div class='bubles'>";
      bubles += "<div id='buble-1' class='buble selec-buble'></div>";
      for(var i = 2; i <= this.itemsCount; i++)
        bubles += "<div id='buble-" + i + "' class='buble'></div>";

      bubles += "</div>";
      $(this.$el).append(bubles);

      /*fix height .text*/
      var _height = this.$container.height() - this.$el.find('.bubles').height() - this.$el.find('.button').height() - (29 * window.innerHeight / 768);
      $(".banner-item .text").css({"height": _height + "px","margin":"14px 50px 7px 230px", "line-height":"1.1em"});
    },

    _setItems			: function() {
      this.$items.removeClass('dg-center');
      this.$currentItm	= this.$items.eq( this.current );
      this.$leftItm		= ( this.current === 0 ) ? this.$items.eq( this.itemsCount - 1 ) : this.$items.eq( this.current - 1 );
      this.$rightItm		= ( this.current === this.itemsCount - 1 ) ? this.$items.eq( 0 ) : this.$items.eq( this.current + 1 );

      // next & previous items
      if( this.itemsCount > 3 )
      {
        // next item
        this.$nextItm		= ( this.$rightItm.index() === this.itemsCount - 1 ) ? this.$items.eq( 0 ) : this.$rightItm.next();
        this.$nextItm.css( this._getCoordinates('outright') );
        // previous item
        this.$prevItm		= ( this.$leftItm.index() === 0 ) ? this.$items.eq( this.itemsCount - 1 ) : this.$leftItm.prev();
        this.$prevItm.css( this._getCoordinates('outleft') );
      }
    },

    _loadEvents			: function() {
      $(window).resize(function(){
        _self._zoom = window.innerHeight / 768;
        this._translateX = window.innerWidth / _self._zoom;
        alert(" _zoom:" + _self._zoom + " _translateX:" + this._translateX);
      });
      var _self	= this;
      this.$wrapper.on( 'webkitTransitionEnd.banner-item transitionend.banner-item OTransitionEnd.banner-item', function( event ) {
        _self.$currentItm.addClass('dg-center');
        _self.$items.css({
          '-webkit-transition'  : '',
          '-moz-transition'     : '',
          '-o-transition'       : '',
          '-ms-transition'      : '',
          'transition'          : ''
        });
        _self.isAnim  = false;
        _self.isMove  = false;

        $('.buble').removeClass('selec-buble');
        $('#buble-' + (_self.current + 1)).addClass('selec-buble');
      });

      this.$container.on('click', function(e) {
        if( _self.isMove )
          return false;

        var tubPosition = e.pageX / _self._zoom;
        var leftBoundaryPoint = _self.$wrapper[0].offsetLeft;
        var rightBoundaryPoint = _self.$wrapper[0].offsetLeft + _self._translateX;
        var offset = _self._translateX / _self._zoom / 2;

        if( (_self.support3d && _self.supportTrans) )
        {
          if ((tubPosition < leftBoundaryPoint) && (tubPosition > (leftBoundaryPoint - offset)))
          {
            try{
              window.location.href =  _self.$leftItm[0].href;
            } catch(error) {
              console.log(error.name+' - '+ error.message);
            }
          }
          else
          if((tubPosition > rightBoundaryPoint) && (tubPosition < (rightBoundaryPoint + offset)))
          {
            window.location.href =  _self.$rightItm[0].href;
            //_self.$rightItm[0].click();
          }
        }
      });

      this.$container.bind('movestart', function(e) {
        if(_self.isAnim)
          return false;
        /* It is checking. If we tap in two places then the second will be ignored */
        var testPageX = _self.pageX - e.pageX;
        testPageX = (testPageX>0)?testPageX:testPageX*(-1);
        if(testPageX>200 & _self.pageX != 0)
          return false;
        else
          _self.pageX = e.pageX;

        if (_self.isMove)
          return false;

        _self.startMove = true;
        _self.Distance = 0;
        _self._shift = 0;
        if( _self.options.autoplay ) {
          clearTimeout( _self.slideshow );
          _self.options.autoplay	= false;
        }
        _self.isMove = true;
      }).bind('move', function(e) {
        if( _self.isAnim )
          return false;

        /* It is checking. If we tap in two places then the second will be ignored */
        var testPageX = _self.pageX - e.pageX;
        testPageX = (testPageX>0)?testPageX:testPageX*(-1);
        if(testPageX>500)
          return false;
        else
          _self.pageX = e.pageX;

        _self.lineMotion = (e.deltaX < 0) ? 'next' : 'prev';
        var timestamp  = utils.getTime();
        if ( timestamp - _self.startTime > 300 )
        {
          _self.startTime = timestamp;
          _self.startX = e.pageX/_self._zoom;
        }
        _self.Distance = e.startX/_self._zoom - e.pageX/_self._zoom - _self._shift;
        /* todo */
//        return false;
        if( !(_self.support3d && _self.supportTrans) )
          return false;

        if (_self.Distance > _self._translateX)
        {
          _self.Distance = 0;
          _self._shift += _self._translateX;
          _self.current	= _self.$rightItm.index();
          _self._setItems();
        }
        else
        if((-1 * _self.Distance) > _self._translateX)
        {
          _self.Distance = 0;
          _self._shift -= _self._translateX;
          _self.current	= _self.$leftItm.index();
          _self._setItems();
        }
        //_self._displacement(_self.Distance);
      }).bind('moveend', function(e) {
        _self.startMove = false;
        _self.pageX = 0;

        if( !(_self.support3d && _self.supportTrans) )
          return _self._navigate(_self.lineMotion, 5);

        var duration = utils.getTime() - _self.startTime,
        speed = 0;

        // start momentum animation if needed
        if ( duration < 300 )
          speed = Math.abs(e.pageX/_self._zoom - _self.startX) / duration;

        if( speed > 1.8 )
        {
          _self._endDisplacement();
        }
return;
        if( speed < 0.8 )
        {
          _self._endDisplacement();
        }
        else
        {
          _self._moveTo = (_self.lineMotion == 'next')?  _self._translateX - _self.Distance : -_self._translateX - _self.Distance;
          //_self._moveTo = (_self.lineMotion == 'next')?  10 : -10;
          _self._startDisplacement();
          alert("v5 _moveTo:" + _self._moveTo + " speed:" + speed + " _translateX:" + _self._translateX + " / " + _self.Distance);
        }
      });
    },

    _startDisplacement: function () {
      var _self	= this;
      if (_self.startMove)
      {
        return false;
        clearTimeout(_self.Displacement);
      }

      _self.Distance += _self._moveTo/1.7;
      _self._moveTo -= _self._moveTo/1.7;

      if (_self.Distance > _self._translateX)
      {
        //_self.Distance = 0;
        _self.Distance -= _self._translateX;
        //_self._shift += _self._translateX;
        _self.current	= _self.$rightItm.index();
        _self._setItems();
      }
      else
      if((-1 * _self.Distance) > _self._translateX)
      {
        //_self.Distance = 0;
        _self.Distance += _self._translateX;
        _self.current	= _self.$leftItm.index();
        _self._setItems();
      }
      this._displacement(this.Distance);
      this.Displacement	= setTimeout( function() {
        if( !(_self._moveTo < 1 && _self._moveTo > -1 ) )
        {
          _self._startDisplacement();
        }
        else
        {
          clearTimeout(_self.Displacement);
          _self._endDisplacement();
        }
      }, 1000/60 );
    },

    _endDisplacement: function () {
      var _self	= this,
        border_passage = _self._translateX / 2,
        lineMotion = 'next',
        speed = 5;

      if( _self.Distance < border_passage && _self.Distance > (-1 * border_passage))
      {
        lineMotion = 'stay';
      }
      else
      {
        if(_self.Distance < 0)
        {
          lineMotion = 'prev';
          _self.Distance *= -1;
        }
        else
        {
          lineMotion = 'next';
        }
      }
      _self.Distance = (_self.Distance < border_passage)? _self.Distance : _self._translateX - _self.Distance;
      speed = Math.round(_self.Distance / 100);
      speed = (speed > 0) ? speed : -1 * speed;
      speed += 1;
      _self._navigate(lineMotion, speed);

      _self.options.autoplay = true;
      _self._startSlideshow();
    },

    _getCoordinates		: function( position ) {
      switch( position ) {
      case 'outleft':
        return {
          '-webkit-transform'	: 'translateX(-'+(100+this._translateX)+'px)',
          '-moz-transform'	: 'translateX(-'+(100+this._translateX)+'px)',
          '-o-transform'		: 'translateX(-'+(100+this._translateX)+'px)',
          '-ms-transform'		: 'translateX(-'+(100+this._translateX)+'px)',
          'transform'			  : 'translateX(-'+(100+this._translateX)+'px)',
          'opacity'			    : 0,
          'visibility'		  : 'visible'
        };
        break;
      case 'outright':
        return {
          '-webkit-transform'	: 'translateX('+(100+this._translateX)+'px)',
          '-moz-transform'	: 'translateX('+(100+this._translateX)+'px)',
          '-o-transform'		: 'translateX('+(100+this._translateX)+'px)',
          '-ms-transform'		: 'translateX('+(100+this._translateX)+'px)',
          'transform'			  : 'translateX('+(100+this._translateX)+'px)',
          'opacity'			    : 0,
          'visibility'		  : 'visible'
        };
        break;
      case 'left':
        return {
          '-webkit-transform'	: 'translateX(-'+this._translateX+'px)',
          '-moz-transform'	: 'translateX(-'+this._translateX+'px)',
          '-o-transform'		: 'translateX(-'+this._translateX+'px)',
          '-ms-transform'		: 'translateX(-'+this._translateX+'px)',
          'transform'			  : 'translateX(-'+this._translateX+'px)',
          'opacity'			    : 1,
          'visibility'		  : 'visible'
        };
        break;
      case 'right':
        return {
          '-webkit-transform'	: 'translateX('+this._translateX+'px)',
          '-moz-transform'	: 'translateX('+this._translateX+'px)',
          '-o-transform'		: 'translateX('+this._translateX+'px)',
          '-ms-transform'		: 'translateX('+this._translateX+'px)',
          'transform'			  : 'translateX('+this._translateX+'px)',
          'opacity'			    : 1,
          'visibility'		  : 'visible'
        };
        break;
      case 'center':
        return {
          '-webkit-transform'	: 'translateX(0px)',
          '-moz-transform'	: 'translateX(0px)',
          '-o-transform'		: 'translateX(0px)',
          '-ms-transform'		: 'translateX(0px)',
          'transform'			  : 'translateX(0px)',
          'opacity'			    : 1,
          'visibility'		  : 'visible'
        };
        break;
      };
    },

    _getTransition  :function(spead){
      return {
        '-webkit-transition'  : 'all 0.'+spead+'s ease-in-out',
        '-moz-transition'     : 'all 0.'+spead+'s ease-in-out',
        '-o-transition'       : 'all 0.'+spead+'s ease-in-out',
        '-ms-transition'      : 'all 0.'+spead+'s ease-in-out',
        'transition'          : 'all 0.'+spead+'s ease-in-out'
      };
    },

    _navigate			: function( dir, spead ) {
      if( this.isAnim )
        return false;
      /* Иногда может прийти spead = 0. А при таком значении не произойдет событие TransitionEnd.gallery
      в котором происходит возврат к начальному состоянию (isAnim = false) и мы не можем двигать карусель */
      if(spead !== 0)
        this.isAnim	= true;

      switch( dir ) {
        case 'next' :
          this.current	= this.$rightItm.index();
          // current item moves left
          this.$currentItm.css( this._getTransition(spead) ).css( this._getCoordinates('left') );
          // right item moves to the center
          this.$rightItm.css( this._getTransition(spead) ).css( this._getCoordinates('center') );
          // next item moves to the right
          if( this.$nextItm ) {
            // left item moves out
            this.$leftItm.css( this._getTransition(spead) ).css( this._getCoordinates('outleft') );
            this.$nextItm.css( this._getTransition(spead) ).css( this._getCoordinates('right') );
          }
          else {
            // left item moves right
            this.$leftItm.css( this._getTransition(spead) ).css( this._getCoordinates('right') );
          }
          break;
        case 'prev' :
          this.current	= this.$leftItm.index();
          // current item moves right
          this.$currentItm.css( this._getTransition(spead) ).css( this._getCoordinates('right') );
          // left item moves to the center
          this.$leftItm.css( this._getTransition(spead) ).css( this._getCoordinates('center') );
          // prev item moves to the left
          if( this.$prevItm ) {
            // right item moves out
            this.$rightItm.css( this._getTransition(spead) ).css( this._getCoordinates('outright') );
            this.$prevItm.css( this._getTransition(spead) ).css( this._getCoordinates('left') );
          }
          else {
            // right item moves left
            this.$rightItm.css( this._getTransition() ).css( this._getCoordinates('left') );
          }
          break;
        case 'stay' :
          this.$currentItm.css( this._getTransition(spead) ).css( this._getCoordinates('center') );
          this.$leftItm.css( this._getTransition(spead) ).css( this._getCoordinates('left') );
          this.$rightItm.css( this._getTransition(spead) ).css( this._getCoordinates('right') );
          this.$prevItm.css( this._getTransition(spead) ).css( this._getCoordinates('outleft') );
          this.$nextItm.css( this._getTransition(spead) ).css( this._getCoordinates('outright') );
          this.isAnim	= false;
          return false;
          break;
      };

      this._setItems();
      this.$currentItm.addClass('dg-center');
    },

		_displacement			: function( dir ) {
			if( dir > 0)
      {
        if (dir > this._translateX)
          return false;

        var outL = 100*(dir/this._translateX);

				this.current	= this.$rightItm.index();

        // current item moves left
        this.$currentItm.css(  {
          '-webkit-transform' : 'translateX(-'+ dir +'px)',
          '-moz-transform'    : 'translateX(-'+ dir +'px)',
          '-o-transform'      : 'translateX(-'+ dir +'px)',
          '-ms-transform'     : 'translateX(-'+ dir +'px)',
          'transform'         : 'translateX(-'+ dir +'px)',
          'opacity'           : 1,
          'visibility'        : 'visible'
        } );
        // right item moves to the center
        this.$rightItm.css(  {
          '-webkit-transform' : 'translateX('+ (100+this._translateX - dir) +'px)',
          '-moz-transform'    : 'translateX('+ (100+this._translateX - dir) +'px)',
          '-o-transform'      : 'translateX('+ (100+this._translateX - dir) +'px)',
          '-ms-transform'     : 'translateX('+ (100+this._translateX - dir) +'px)',
          'transform'         : 'translateX('+ (100+this._translateX - dir) +'px)',
          'opacity'           : 1,
          'visibility'        : 'visible'
        } );

        this.$leftItm.css( {
          '-webkit-transform' : 'translateX(-' + (this._translateX + outL) + 'px)',
          '-moz-transform'    : 'translateX(-' + (this._translateX + outL) + 'px)',
          '-o-transform'      : 'translateX(-' + (this._translateX + outL) + 'px)',
          '-ms-transform'     : 'translateX(-' + (this._translateX + outL) + 'px)',
          'transform'         : 'translateX(-' + (this._translateX + outL) + 'px)',
          'opacity'           : 0,
          'visibility'        : 'visible'
        } );
        this.$nextItm.css( {
          '-webkit-transform' : 'translateX(' + (100+this._translateX - outL) + 'px)',
          '-moz-transform'    : 'translateX(' + (100+this._translateX - outL) + 'px)',
          '-o-transform'      : 'translateX(' + (100+this._translateX - outL) + 'px)',
          '-ms-transform'     : 'translateX(' + (100+this._translateX - outL) + 'px)',
          'transform'         : 'translateX(' + (100+this._translateX - outL) + 'px)',
          'opacity'           : 1,
          'visibility'		    : 'visible'
        });
      }
      else
      {
        dir *= -1;
        if (dir > this._translateX)
          return false;

        var outL = 100*(dir/this._translateX);

        this.current	= this.$leftItm.index();

        this.$currentItm.css(  {
          '-webkit-transform' : 'translateX('+ dir +'px)',
          '-moz-transform'    : 'translateX('+ dir +'px)',
          '-o-transform'      : 'translateX('+ dir +'px)',
          '-ms-transform'     : 'translateX('+ dir +'px)',
          'transform'         : 'translateX('+ dir +'px)',
          'opacity'           : 1,
          'visibility'        : 'visible'
        } );

        this.$leftItm.css(  {
          '-webkit-transform' : 'translateX(-'+ (100+this._translateX - dir) +'px)',
          '-moz-transform'    : 'translateX(-'+ (100+this._translateX - dir) +'px)',
          '-o-transform'      : 'translateX(-'+ (100+this._translateX - dir) +'px)',
          '-ms-transform'     : 'translateX(-'+ (100+this._translateX - dir) +'px)',
          'transform'         : 'translateX(-'+ (100+this._translateX - dir) +'px)',
          'opacity'           : 1,
          'visibility'        : 'visible'
        } );

        this.$rightItm.css( {
          '-webkit-transform'	: 'translateX(' + (this._translateX - outL) + 'px)',
          '-moz-transform'    : 'translateX(' + (this._translateX - outL) + 'px)',
          '-o-transform'      : 'translateX(' + (this._translateX - outL) + 'px)',
          '-ms-transform'     : 'translateX(' + (this._translateX - outL) + 'px)',
          'transform'         : 'translateX(' + (this._translateX - outL) + 'px)',
          'opacity'           : 0,
          'visibility'        : 'visible'
        } );

        this.$prevItm.css( {
          '-webkit-transform' : 'translateX(-' + (100+this._translateX - outL) + 'px)',
          '-moz-transform'    : 'translateX(-' + (100+this._translateX - outL) + 'px)',
          '-o-transform'      : 'translateX(-' + (100+this._translateX - outL) + 'px)',
          '-ms-transform'     : 'translateX(-' + (100+this._translateX - outL) + 'px)',
          'transform'         : 'translateX(-' + (100+this._translateX - outL) + 'px)',
          'opacity'           : 1,
          'visibility'        : 'visible'
        });
			};
		},

    _startSlideshow		: function() {
      var _self	= this;
      this.slideshow	= setTimeout( function() {
        _self._navigate( 'next', 9 );
        if( _self.options.autoplay )
        {
          _self._startSlideshow();
        }
      }, this.options.interval );
    },

    destroy				: function() {
      this.$wrapper.off('.banner');
    }
  };

  var logError 			= function( message ) {
    if ( this.console )
    {
      console.error( message );
    }
  };
	
  $.fn.banner			= function( options ) {
    if ( typeof options === 'string' )
    {
      var args = Array.prototype.slice.call( arguments, 1 );
      this.each(function() {
        var instance = $.data( this, 'banner' );
        if ( !instance )
        {
          logError( "cannot call methods on banner prior to initialization; " +
          "attempted to call method '" + options + "'" );
          return;
        }
        if ( !$.isFunction( instance[options] ) || options.charAt(0) === "_" )
        {
          logError( "no such method '" + options + "' for banner instance" );
          return;
        }
        instance[ options ].apply( instance, args );
      });
    }
    else
    {
      this.each(function() {
        var instance = $.data( this, 'banner' );
        if ( !instance ) {
          $.data( this, 'banner', new $.Banner( options, this ) );
        }
      });
    }
    return this;
  };

  /*
  * взял утилиту из библиотеки IScroll
  *
  */
  var utils = (function () {
    var me = {};

    me.getTime = Date.now || function getTime () { return new Date().getTime(); };
    me.getTouch = function (_evt) {

      var x = 0;//whw.w;
      var y = 0;//whw.h;
      var flag = true;
      if (typeof _evt.touches != 'undefined')
      {
        if (_evt.touches.length > 0)
        {
          if (typeof _evt.touches[0].clientX != 'undefined' && typeof _evt.touches[0].clientY != 'undefined')
          {
            x = _evt.touches[0].clientX;
            y = _evt.touches[0].clientY;
          }
          else
          {
            x = _evt.touches[0].pageX;
            y = _evt.touches[0].pageY;
          }
          flag = false;
        }
      }
      if (flag)
      {
        if (typeof _evt.clientX != 'undefined' && typeof _evt.clientY != 'undefined')
        {
          x = _evt.clientX;
          y = _evt.clientY;
        }
        else
        {
          x = _evt.pageX;
          y = _evt.pageY;
        }
      }
      return {x: x, y: y}
    }

    return me;
  })();

})( jQuery );
