if (!window.requestAnimationFrame)
{
  window.requestAnimationFrame = ( function() {
    return window.webkitRequestAnimationFrame ||
      window.mozRequestAnimationFrame ||
      window.oRequestAnimationFrame ||
      window.msRequestAnimationFrame ||
      function( /* function FrameRequestCallback */ callback, /* DOMElement Element */ element ) {
        window.setTimeout( callback, 1000 / 60 );
      };
  })();
}

window.onerror = function(message, source, lineno) {
  console.log("message:" + message + " source:" + source + " lineno:" + lineno);
  return false;
};

var locale;
var mainGames = [];
var flagToStore = true;
var appendLocale = {};
var dt = new Date().getTime();
var varArr = {'st':{}, 'adv':{}};
var bnArr = {'hrefFirst': '', 'cnt': 0,'active': 0, 'timer': 0, 'status' : false, 'viewed': false};
var userAgent = navigator.userAgent.toLowerCase();
var isIpadNew = isIpadNewFunc();
var countShowGame = 18;
var hasScroll = false;
var XPROMO_SITE = 'http://xpromo.g5e.com/v1/';
var bannerDir = "news";
var BANNER_SITE = XPROMO_SITE + bannerDir + '/';
var self_id = gamesSelfId();
var touchEvent = window.navigator.msPointerEnabled ? 'MSPointerDown' : 'touchstart';
var usePGPL = false;
var sortList = {};
var settingsOfPage = {type:'lp', 'link': {'prefix': 'lp', 'upsell': 'lp_upsell', 'promo': 'lp_promo'}, 'log': 'landing_page'};
var sizeArr = {'timer': 0, 'height': 0, 'width': 0, 'flag': true};
if (typeof window.platform == 'undefined')
{
  window.platform = window.localStorage.getItem('xpromo.platform');
  if (!window.platform)
    window.platform = 'iPad';
}
var ifArr = {};
var gamesDirectiveEmpty = {
  "li" :
  {
    "game<-games" :
    {
      "@data-id" : "game.id",
      ".icon@alt_img" : function(arg) {
        if(isIpadNew)
          return arg.item.id;
        return '';
      },
      ".icon@class+" : function(arg) {
        return getIconClass(arg.item.id);
      }
    }
  }
};
var gamesDirective = jQuery.extend(true, {}, gamesDirectiveEmpty);
gamesDirective['li']['game<-games']['.name'] = 'game.name_short';
gamesDirective['li']['game<-games']['.icon@style'] = function(arg) {
  return 'background-image:url(' + arg.item.id + "/" + iconNameFor(arg.item.id) + ');' + iconStyleFor(arg.item.id, 3);
};
gamesDirective['li']['game<-games']['a@href'] = 'game.href';
function checkVisibilityProperty() {
  if (typeof document.hidden !== "undefined")
    return {'property': 'hidden', 'event': 'visibilitychange'};
  var prefixes = ['webkit','ms','moz','o']
  for (var i in prefixes)
  {
    if (typeof document[prefixes[i] + 'Hidden'] != 'undefined')
      return {'property': prefixes[i] + 'Hidden', 'event': prefixes[i] + 'visibilitychange'};
  }
  return null;
}
(function() {
  ifArr['trident'] = {'is': (userAgent.indexOf("trident") != -1)};
  var tmp;
  var regArr = {
    'android': /(Android )([0-9])/i,
    'iphone': /((iphone;)|(ipod;)).+(os )([0-9]+)/i,
    'ipad': /(ipad;).+(os )([0-9])/i,
    'macintosh': /(macintosh;).+(OS X )([0-9]+)/i
  };
  for (var i in regArr)
  {
    ifArr[i] = {'is': false, 'ver': 0};
    tmp = userAgent.match(regArr[i]);
    if (tmp !== null)
      ifArr[i] = {'is': true, 'ver' : parseInt(tmp[tmp.length - 1])};
  }
  ifArr['ios'] = {'is': false, 'ver': 0};
  if (ifArr.iphone.is || ifArr.ipad.is)
    ifArr['ios'] = {'is': true, 'ver': Math.max(ifArr.iphone.ver, ifArr.ipad.ver)};
  ifArr.bag = {};
  /* iPad 7_0_2 bug? correct width for iPhone version game running on the iPad(LFNII-970)   */
  ifArr.bag['ios_7_0_2'] = (userAgent.indexOf("7_0_2") != -1 && ifArr.ipad.is && "iphone" == platform.toLowerCase());
  ifArr['tv'] = {'is': false};
  var _id = window.localStorage.getItem("xpromo.id");
  if (_id != null)
  {
    _id = _id.split('.');
    if (_id.indexOf('tv') > -1)
    {
      ifArr['tv'].is = true;
      $('body').addClass('tv');
      $('.logo').removeAttr('href');
    }
  }
})();
function setViewed() {
  bnArr.viewed = true;
}
$(document).ready(function(){
  //setIf();
  $(window).resize(function(){
    updateLayout();
  });
  updateLayout();
  var visibility = checkVisibilityProperty();
  if ($('.button-exit.back').length > 0)
  {
    settingsOfPage.type = 'mg';
    settingsOfPage.link.prefix = 'more_games';
    settingsOfPage.link.promo = settingsOfPage.link.prefix;
    settingsOfPage.link.upsell = settingsOfPage.link.prefix;
    settingsOfPage.log = 'more_games';
    if (visibility !== null && typeof document.addEventListener != "undefined")
    {
      if (!document[visibility.property])
      {
        document.addEventListener(visibility.event, setViewed, false);
      }
      else
      {
        setTimeout(setViewed, 500);
      }
    }
    else
    {
      requestAnimationFrame(setViewed);
    }
  }
  else
  {
    requestAnimationFrame(function(){setTimeout(setViewed, 500)});
  }
  try{
    locale = lockitRender();
    var mainLocale = lockitLoad('main');
    if (mainLocale.banners)
      locale.banners = mainLocale.banners;
    mainRender();
  }
  catch(e) {
    //
  }
  setKeyBoardTv();
  $('.page-header, .logo').on(touchEvent, function(e){
    if (ifArr.ios.is)
    {
      var th = $(this);
      if (th.filter('.logo').length > 0)
        myLogLP('site', true, 'logo');
      window.open(th.attr('href'));
      return false;
    }
  });
  $('.logo').on('click.log', function(){
      myLogLP('site', true, 'logo');
  });
  //$('.select-type b').on(touchEvent, function(e){e.preventDefault();});
});
function getIconClass(_id) {
  var tmp = getPlatformFromId(_id);
  if (tmp == 'android')
    return ' icon_android';
  if (['mac', 'winrt', 'winphone'].indexOf(tmp) != -1)
    return ' icon_mac';
  return '';
}
function mainRender() {
  var game = gamesLoadGame(xpromoGames, gamesSelfId());
  $p(".page-header").autoRender(game, {
    ".name"       : "name",
    ".icon@style" : function(arg) {
      var variant = '-big';
      return "background-image: url(" + arg.context.id + "/" + iconNameFor(arg.context.id, variant) + ")";
    },
    ".icon@class+" : function(arg) {
      return getIconClass(arg.context.id);
    }
  });
  listRender();
}
function listRender() {
  var tmp = null,
    cntGenre = 0,
    cntGenrePGPL = 0,
    index = 0,
    games = [],
    arr = {}, i, j, bundle, gamesBox, mx, el;
  var cnt = parseInt(window.localStorage.getItem("xpromo.games.count"));
  if (isNaN(cnt))
    cnt = 0;
  for (j in varArr)
    varArr[j].games = [];
  for(i = 0; i < cnt; i++)
  {
    tmp = window.localStorage.getItem("xpromo.games." + i + ".id");
    if (tmp != null && typeof xpromoGames[tmp] != 'undefined' && tmp != self_id)
    {
      arr = $.extend({}, xpromoGames[tmp]);
      arr.id = tmp;
      games.push(arr);
      if (typeof xpromoGenre == 'object')
      {
        arr.genre = 'adv';
        bundle = tmp.split('.').slice(0, 3).join('.');
        if (typeof xpromoGenre[bundle] != 'undefined')
          arr.genre = xpromoGenre[bundle].toLowerCase();
        for (j in varArr)
        {
          if ([j, 'both'].indexOf(arr.genre) != -1)
            varArr[j].games.push(arr);
        }
      }
    }
  }
  sortList['pplr'] = replaceSort(games, false);
  sortList['rcnt'] = replaceSort(games, true);
  games = [];
  for(j in sortList)
  {
    for (i in sortList[j])
      sortList[j][i] = sortList[j][i]['id'];
  }
  for (j in varArr)
  {
    cntGenre += varArr[j].games.length;
    cntGenrePGPL += Math.min(varArr[j].games.length, 10);
    $('.games-box.' + j).autoRender({'games': varArr[j].games}, gamesDirectiveEmpty);
  }
  if (cntGenre > 0)
    $('#recent strong, #popular strong').append(' <i>(' + cntGenre + ')</i>');
  if (cntGenrePGPL == 0)
    usePGPL = false;
  if (usePGPL)
  {
    $('#friends strong').append(' <i>(' + cntGenrePGPL + ')</i>');
    $('#friends div').appendTo('#friends strong');
  }
  else
  {
    moveStar();
  }
  if (typeof window['getActiveTab'] == 'function')
    index = getActiveTab('lp');
  $('.select-type a').eq(index).addClass('selected');
  sortListElement();
  countShowGame = Math.ceil(($('.games-box').eq(0).width() + 1500) / 147);
  setScroll();
  for (j in varArr)
  {
    gamesBox = $('.games-box.' + j);
    el = gamesBox.find('li');
    mx = Math.min(el.length, countShowGame);
    for(i = 0; i < mx; i++)
      loadLi(el.eq(i));
  }
  $('.games-box ul li:not(.loaded)').each(function(){
    loadLi($(this));
  });
  $('.games-box').on('click', 'a', function(e) {
    if (!flagToStore)
    {
      e.preventDefault();
      return false;
    }
    flagToStore = false;
    setTimeout(function(){flagToStore = true;}, 500);
    var _identifier = $(this).parents('li').eq(0).attr('data-id');
    myLogLP(_identifier, true, 'upsell');
  });
  setTimeout(renderGames, 1000);
}
function sortListElement() {
  var sortType = $('.select-type a.selected').attr('data-type');
  var el;
  for(var i in varArr)
  {
    el = $('.games-box.' + i + ' li');
    if (el.length > 0)
    {
      tinysort(el, {
        sortFunction: function (a, b) {
          var a_index = sortList[sortType].indexOf($(a.elm).attr('data-id'));
          var b_index = sortList[sortType].indexOf($(b.elm).attr('data-id'));
          return a_index === b_index ? 0 : (a_index > b_index ? 1 : -1);
        }
      });
    }
  }
}
function moveStar() {
  $('#friends div').appendTo('#recent strong');
  $('#recent').addClass('with_image');
  $('#friends').remove();
}
function loadLi(_el) {
  var id = _el.attr('data-id');
  if (typeof appendLocale[id] == 'undefined')
  {
    appendLocale[id] = gamesLoadGame(xpromoGames, id);
    appendLocale[id].href = getLink(appendLocale[id]);
  }
  if (!appendLocale[id].href)
  {
    _el.remove();
  }
  else
  {
    _el.addClass('loaded');
    _el.find('.icon').css('background-image','url(' + id + "/" + iconNameFor(id) + ')');
    _el.find('.name').html(appendLocale[id].name_short);
    _el.find('a').attr('href', appendLocale[id].href);
  }
}
function getLink(_locale) {
  var ret = false;
  if (!_locale.links)
    return false;
  var arr = ['download', 'free', 'lite', 'full', 'temp'];
  for (var i in arr)
  {
    if(arr[i] in _locale.links)
    {
      if (arr[i] == 'temp')
      {
        if (mainGames.length <= 5)
        {
          ret = _locale.links[arr[i]];
          break;
        }
      }
      else
      if (_locale.date.getTime() < dt)
      {
        ret = _locale.links[arr[i]];
        break;
      }
    }
  }
  if (typeof ret == 'string')
  {
    if (ret.indexOf('javascript:') == -1)
    {
      if ('hastrk3LP' in _locale.links && _locale.links.hastrk3LP != '')
      {
        ret = convertLink("@ext(" + _locale.links.hastrk3LP + ")", '', '&sub_campaign=' + settingsOfPage.link.upsell);
      }
      else
      {
        ret = convertLink("@ext(" + ret + ")", _locale.links.hastrk3, '&sub_campaign=' + settingsOfPage.link.upsell);
      }
    }
  }
  return ret;
}
function renderGames() {
  var i, j, id,
    cntGames = 0,
    cntGamesPGPL = 0;
  for (j in varArr)
  {
    for (i in varArr[j].games)
    {
      id = varArr[j].games[i].id;
      if (typeof appendLocale[id] == 'undefined')
      {
        appendLocale[id] = gamesLoadGame(xpromoGames, id);
        appendLocale[id].href = getLink(appendLocale[id]);
      }
      varArr[j].games[i] = $.extend({}, appendLocale[id]);
    }
    varArr[j].games = varArr[j].games.filter(function(element){
      return (!!element.href);
    });
    cntGames += varArr[j].games.length;
  }
  if (usePGPL)
  {
    if (cntGamesPGPL > 0)
    {
      $('#friends strong i').html('(' + cntGamesPGPL + ')');
    }
    else
    {
      moveStar();
      usePGPL = false;
    }
  }
  if (cntGames > 0)
  {
    $('#recent strong i, #popular strong i').html('(' + cntGames + ')');
    $('.select-type a').on(touchEvent, changeType).on('mousedown', changeType);
  }
  else
  {
    $('#recent strong i, #popular strong i').remove();
  }
}
function setScroll(_flag) {
  if (!_flag)
  {
    /* iPad 7_0_2 bug? correct width for iPhone version game running on the iPad(LFNII-970)   */
    if (ifArr.bag['ios_7_0_2'])
      $('.main').width(window.innerWidth / (window.innerHeight / 768) + "px");

    hasScroll |= (ifArr.ios.is && ifArr.ios.ver > 4);

    hasScroll |= ifArr.trident.is;
    if (settingsOfPage.type == 'mg' && ifArr.ios.is)
    {
      if (xpromoGames.hasOwnProperty(self_id) && xpromoGames[self_id]['date'].getFullYear() < 2014)
      {
        hasScroll = false;
        $(document).bind('touchmove', function(e){e.preventDefault();});
      }
    }
  }
  if (!hasScroll)
  {
    var maxScroll = 0;
    var myScrollSettings = {
      scrollX:true,
      scrollY:false,
      mouseWheel: ifArr.macintosh.is,
      tap: false,
      click: true
    };
    for (var i in varArr)
    {
      varArr[i]['gameBox'] = $('.games-box.' + i + '>div');
      varArr[i]['myScroll'] = new IScroll(varArr[i]['gameBox'][0],myScrollSettings);
      if (varArr[i]['myScroll'].maxScrollX < 0)
      {
        maxScroll = Math.max(varArr[i]['myScroll'].maxScrollX, -1500);
        varArr[i]['myScroll'].scrollTo(maxScroll, 0, 0);
      }
    }
    setTimeout(bannerFirstRender, 0);
  }
  else
  {
    if ($('.middle-block').width() > 10)
    {
      setScroll2();
      setTimeout(bannerFirstRender, 0);
    }
    else
    {
      //hack for WinRT
      setTimeout(function(){setScroll(true);}, 50);
    }
  }
}
function setScroll2(_flag) {
  var gamesBoxUl, start;
  var _width = $('.middle-block').width();
  for (var i in varArr) {
    varArr[i]['gameBox'] = $('.games-box.' + i + '>div');
    gamesBoxUl = varArr[i]['gameBox'].find('ul');
    start = Math.min(gamesBoxUl.width() - _width, 1500);
    if (start > 0)
    {
      gamesBoxUl.css({
        'transform': 'translate3d(-' + start + 'px, 0px, 0px)',
        '-webkit-transform': 'translate3d(-' + start + 'px, 0px, 0px)',
        'transition': 'transform 0s linear',
        '-webkit-transition': '-webkit-transform 0s linear'
      });
    }
  }
  if (_flag)
    requestAnimationFrame(scrollGame);
}
function scrollGame() {
  var startT = new Date().getTime();
  var cnt = 0;
  for (var i in varArr)
  {
    if (!hasScroll)
    {
      varArr[i]['myScroll'].scrollTo(0, 0, 4000);
    }
    else
    {
      varArr[i]['gameBox'].css({
        'overflow-x': 'scroll',
        '-ms-overflow-style': '-ms-autohiding-scrollbar',
        'overflow-scrolling': 'touch',
        '-webkit-overflow-scrolling': 'touch'
      });
      varArr[i]['gameBox'][0].addEventListener('webkitTransitionEnd', function() {
        //hack for iOS
        var dur = (new Date().getTime()) - startT;
        if (dur < 3000)
        {
          cnt++;
          if (cnt == 2)
            setScroll2(true);
          return;
        }
        $(this).css({
          'overflow-scrolling': 'touch',
          '-webkit-overflow-scrolling': 'touch'
        }).find('ul').css({
          'transform': 'translate3d(0px, 0px, 0px)',
          '-webkit-transform': 'translate3d(0px, 0px, 0px)',
          'transition': 'transform 0s ease',
          '-webkit-transition': '-webkit-transform 0s ease'
        });
      }, false);
      varArr[i]['gameBox'].find('ul').css({
        'transform': 'translate3d(0px, 0px, 0px)',
        '-webkit-transform': 'translate3d(0px, 0px, 0px)',
        'transition': 'transform 4s ease',
        '-webkit-transition': '-webkit-transform 4s ease'
      });
    }
  }
}
function bannerFirstRender () {
  var bannerBase = window.localStorage.getItem("xpromo.news.base");
  if (bannerBase)
  {
    bannerBase = bannerBase.split('/');
    bannerDir = bannerBase[0];
  }
  bnArr.bannerBox = $('.banners-box');
  bnArr.hiddenBox = $('.hidden-box');
  bnArr.hiddenBox.html(bnArr.bannerBox.html());
  bnArr.compiled = bnArr.hiddenBox.find('.banner-item').compile(bannerDirective);
  var content = '';
  var _data = getBannersFromStorage();
  if (typeof _data == 'object')
  {
    _data = getBanners(_data, true);
    if (_data.banners.length > 0)
    {
      _data.banners[0].pos = bnArr.cnt;
      bnArr.cnt++;
      bnArr.hrefFirst = _data.banners[0].href;
      content = bnArr.compiled(_data.banners[0]);
      bnArr.bannerBox.html(content);
      myLogLP(_data.banners[0].identifier);
      renderIndicators(6);
      getBeautyBanner();
    }
  }
  bnArr.bannerBox.on('click.log', '.banner-item', function(){
    myLogLP($(this).attr('data-id'), true);
  }).touchFire({
    swipeLeft: function() {nextBanner();},
    swipeRight: function() {nextBanner(-1);}
  });
  requestAnimationFrame(function(){
    var timeout = 500;
    if (settingsOfPage.type != 'lp')
      timeout = 100;
    setTimeout(function(){
      scrollGame();
      setTimeout(bannersFetch, 4000);
      bnArr.viewed = true;
    }, timeout);
  });
}
function renderIndicators(_num) {
  var tn = $('#indicators');
  var th = tn.find('span');
  var exists = th.length;
  if (exists < _num)
  {
    var fth = th.eq(0);
    for (var i = exists; i < _num; i++)
      fth.clone().insertAfter(fth);
  }
  else
  if (exists > _num)
  {
    th.slice(_num).remove();
  }
  th = tn.find('span');
  if (bnArr.active >= th.length)
    bnArr.active = th.length - 1;
  if (bnArr.active < 0)
    bnArr.active = 0;
  th.removeClass('active').eq(bnArr.active).addClass('active');
  tn.show();
}
function getBannersFromStorage() {
  var content = window.localStorage.getItem('xpromo.banners');
  if (content != null)
    return JSON.parse(content);
  return lockitLoadLangs(bannerDir + '/banners');
}
function getBanners(text, _flag) {
  _flag = !_flag;
  if (_flag)
    window.localStorage.setItem("xpromo.banners", JSON.stringify(text));
  $('.banners-box').css('overflow', 'visible');
  var xpromoBanners = null;
  if (text)
    xpromoBanners = lockitGet(text);

  var data = {};
  data.banners = locale.banners;
  if (xpromoBanners)
    data.banners = data.banners.concat(xpromoBanners.banners);

  data.banners = data.banners.filter(function(element) {
    if (element.begsAt)
    {
      var begsAt = new Date(element.begsAt);
      if (dt < begsAt.getTime())
        return false;
    }

    if (element.endsAt)
    {
      var endsAt = new Date(element.endsAt);
      if (dt >= endsAt.getTime())
        return false;
    }

    if (element.includes)
    {
      var arrIncludes = element.includes.split('|');
      if(!inArray(self_id, arrIncludes))
        return false;
    }

    if (element.excludes)
    {
      var arrExcludes = element.excludes.split('|');
      if(inArray(self_id, arrExcludes) != false)
        return false;
    }

    if(element.hastrk3LP != undefined && element.hastrk3LP != "")
    {
      element.href = convertLink(element.hastrk3LP, '', '&sub_campaign=' + settingsOfPage.link.promo);
    }
    else
    {
      element.href = convertLink(element.href, element.hastrk3, '&sub_campaign=' + settingsOfPage.link.promo);
    }
    if (element.icon)
    {
      element.identifier = element.icon.split('/');
      element.identifier = element.identifier[0];
      element.icon = getIconForBanner(element.icon);
      if (element.icon == '')
        return false;
    }
    else
    if (element.style)
    {
      var tmp = element.style.split('/');
      tmp = tmp[tmp.length - 1];
      tmp = tmp.split("'");
      tmp = tmp[0];
      element.identifier = tmp;
    }
    else
      return false;

    return true;
  });
  if (_flag)
    bannersRender(data);
  return data;
}
function getIconForBanner(_icon) {
  var tmp = _icon;
  var pos = tmp.indexOf('/');
  var ext = 'jpg';
  if(pos != -1)
  {
    tmp = tmp.split('/');
    tmp = tmp[tmp.length - 2];
    var platform = '';
    if (typeof appendLocale[tmp] == 'object' && appendLocale[tmp].hasOwnProperty('id'))
    {
      platform = getPlatformFromId(appendLocale[tmp]['id']);
      if (platform == 'mac')
        ext = 'png';
      return appendLocale[tmp]['id'] + "/icon." + ext;
    }
    var bundle = tmp.split('.');
    bundle = bundle[2];
    for (var i in appendLocale) {
      tmp = appendLocale[i]['id'].split('.');
      tmp = tmp[2];
      if (bundle == tmp)
      {
        platform = getPlatformFromId(appendLocale[i]['id']);
        if (platform == 'mac')
          ext = 'png';
        return appendLocale[i]['id'] + "/icon." + ext;
      }
    }
    if (isIpadNew)
    {
      tmp = _icon.split('/');
      if (tmp.length > 1)
      {
        tmp = tmp[tmp.length - 2];
        platform = getPlatformFromId(tmp);
        if (platform == 'mac')
          ext = 'png';
        return XPROMO_SITE + tmp + '/' + 'icon-big.' + ext;
      }
    }
    return XPROMO_SITE + _icon;
  }
  return '';
}
function bannersFetch() {
  var bannerBase = window.localStorage.getItem("xpromo.news.base");
  if (bannerBase)
  {
    BANNER_SITE = XPROMO_SITE + bannerBase;
    if (bannerBase.indexOf('/') != -1)
      bannerDir = bannerBase.slice(0, bannerBase.indexOf('/'));
    else
      bannerDir = bannerBase;
  }
  var bannerRequest = new XMLHttpRequest();
  bannerRequest.open("GET", BANNER_SITE + "banners.txt", true);
  bannerRequest.onreadystatechange = function(){
    if (this.readyState != 4)
      return;

    var text;
    if (this.status == 200 || this.responseText) // for local GET to work
    {
      text = this.responseText;
      getBanners(JSON.parse(text));
    }
    else
    {
      var t = document.createElement("script");
      t.onerror = function(){
        getBanners(getBannersFromStorage());
      };
      t.src = XPROMO_SITE + 'service/get_banners.php?bannerDir=' + bannerDir + "&bannerFile=banners.txt&functionName=getBanners";
      document.body.appendChild(t);
    }
  };
  bannerRequest.send(null);
}
var bannerDirective = {
  "@id"             : function(arg)
  {
    return "banner-item-" + (arg.context.pos + 1);
  },
  "@class+" : function(arg){
    var ret = '';
    if (arg.context.pos == 0)
      ret += ' show';
    return ret;
  },
  "@data-id"        : "identifier",
  "@href"           : "href",
  "@style"          : function(arg)
  {
    if (typeof arg.context.style == 'string')
      return arg.context.style;
    return '';
  },
  ".icon@style" : function(arg) {
    if (arg.context.icon)
      return "background-image: url('" + arg.context.icon + "')";
    return "display:none;";
  },
  ".icon@alt_img" : function(arg) {
    if(isIpadNew && typeof arg.context.icon == 'string')
    {
      var tmp = arg.context.icon.split('/');
      if (tmp.length > 1 && arg.context.icon.indexOf('-big.') == -1)
        return tmp[tmp.length - 2];
    }
    return '';
  },
  ".icon@class+" : function(arg) {
    if (arg.context.icon)
    {
      var tmp = arg.context.icon.split('/');
      if (tmp.length > 1)
        return getIconClass(tmp[tmp.length - 2]);
    }
    return '';
  },
  "@data-img"       : function(arg)
  {
    if (typeof arg.context.img == 'string' && arg.context.img.length > 0)
      return arg.context.img;
    return '';
  },
  "@data-data"       : function(arg)
  {
    if (typeof arg.context.begsAt == 'string' && arg.context.begsAt.length > 0)
      return arg.context.begsAt;
    return '';
  },
  "div.text"        : "text",
  "div.text+"       : function(arg)
  {
    return arg.context.button ? ("<div class='button'><span>" + arg.context.button + "</span></div>") : "";
  }
};
function bannersRender(_data) {
  var i;
  if (bnArr.cnt == 0)
  {
    bnArr.bannerBox.html('');
  }
  else
  {
    _data.banners = _data.banners.filter(function (element) {return (element.href != bnArr.hrefFirst);});
  }
  _data.banners = _data.banners.slice(0, 6 - bnArr.cnt);
  for (i in _data.banners)
  {
    _data.banners[i].pos = bnArr.cnt;
    bnArr.cnt++;
    bnArr.bannerBox.append(bnArr.compiled(_data.banners[i]));
    if (_data.banners[i].pos == 0)
      myLogLP(_data.banners[i].identifier);
  }
  var el = bnArr.bannerBox.find('.banner-item');
  if (el.length > 1)
  {
    bnArr.status = true;
    bnArr.timer = setTimeout('nextBanner()', 3000);
    renderIndicators(el.length);
    /*$('.banners-box').touchFire({
      swipeLeft: function() {nextBanner();},
      swipeRight: function() {nextBanner(-1);}
    });*/
  }
  else
  {
    $('#indicators').hide();
  }
  if(isIpadNew)
    preloadBigImage();
  setTimeout('getBeautyBanner()', 100);
}
function nextBanner(_pl){
  sizeArr.flag = false;
  if (typeof _pl == 'undefined')
    _pl = 1;
  clearTimeout(bnArr.timer);
  var tn = bnArr.bannerBox.find('a.banner-item');
  if (!bnArr['status'] || tn.length < 2)
    return;
  bnArr['status'] = false;
  var dir = '';
  if (_pl > 0)
    dir = '_left';
  var aid = bnArr.active + _pl;
  if (tn.length > 1)
  {
    if (aid >= tn.length)
      aid = 0;
    if (aid < 0)
      aid = tn.length - 1;
    if (aid != bnArr.active)
    {
      //var bannersBox = $('.banners-box');
      var bannerWidth =  bnArr.bannerBox.width();
      tn.not(':eq(' + bnArr.active + ')').filter('.with_image').addClass('downloaded');
      tn.eq(bnArr.active).blur().animate({
        'transform': 'translateX('+(bannerWidth * -1 * _pl)+'px)'
      }, 1000, 'swing', function() {
        $(this).css({'display': 'hidden'});
        tn.not(':eq(' + bnArr.active + ')').filter('.with_image').addClass('downloaded');
      });
      var nextElement = tn.eq(aid);
      myLogLP(nextElement.attr('data-id'));
      nextElement.css({
        'transform': 'translateX(' + (bannerWidth * _pl) + 'px)',
        'display': 'block'
      }).animate({
        'transform' : 'translateX(0)'
      }, 1000, 'swing', function(){bnArr['status'] = true;fixBanner();if (bnArr.bannerBox.filter('.focused').length > 0) $(this).focus()});
      $('#indicators span').removeClass('active').eq(aid).addClass('active');
      bnArr.active = aid;
      bnArr.timer = setTimeout('nextBanner()', 7000);
    }
  }
}
function updateLayout() {
  if (sizeArr.height == window.innerHeight && sizeArr.width == window.innerWidth)
    return;
  clearTimeout(sizeArr.timer);
  if (ifArr.ios.is)
  {
    if (sizeArr.height < window.innerHeight && sizeArr.flag)
    {
      sizeArr.height = window.innerHeight;
    }
    else if (settingsOfPage.type != 'mg' || !bnArr.viewed)
    {
      sizeArr.height = window.innerHeight;
    }
  }
  else
  {
    sizeArr.height = window.innerHeight;
  }
  /*if ((!ifArr.ios.is || settingsOfPage.type != 'mg' || sizeArr.height < window.innerHeight || !bnArr.viewed) && sizeArr.flag) // MRKT-4370
    sizeArr.height = window.innerHeight;*/
  sizeArr.width = window.innerWidth;
  var zoom = (sizeArr.height / 768) * 100;
  document.body.style.zoom = zoom + "%";
  if (ifArr.trident.is)
  {
    if (zoom>101 && zoom<101.5)
    {
      zoom = Math.round(zoom) - 1;
    }
    else
    if (zoom<100 && zoom>99.5)
    {
      zoom = Math.round(zoom) - 1;
    }

    if (zoom < Math.round(zoom))
      zoom = zoom - 1;

    zoom = Math.round(zoom);
    document.body.style.zoom = "";
    $p(".main")[0].style.zoom = zoom + "%";
    $p(".main")[0].style.width = 100 * 100 / zoom + "%";
    $p(".banners-box")[0].style.borderTopStyle = "none";
  }
  else
  if (ifArr.android.ver < 4 && !ifArr.macintosh.is)
  {
    document.body.style["font-size"] = document.body.style.zoom;
  }

  if (hasScroll)
  {
    for (var i in varArr)
    {
      if (varArr[i]['myScroll'])
        varArr[i]['myScroll'].refresh();
    }
  }
  if (bnArr['status'])
    fixBanner();
  sizeArr.timer = setTimeout(updateLayout, 500);
}
function fixBanner() {
  if (typeof jQuery != 'function')
    return;
  var bannerWidth =  bnArr.bannerBox.width();
  bnArr.bannerBox.find('.banner-item:not(:eq(' + bnArr.active + '))').css({
    'transform': 'translateX(' + bannerWidth + 'px)',
    '-webkit-transform': 'translate(' + bannerWidth + 'px, 0px)'
  });
}
function changeType(e) {
  if (e.type.toLowerCase() != 'mousedown')
  {
    e.preventDefault();
    e.stopPropagation();
  }
  $('.select-type a').removeClass('selected');
  $(this).addClass('selected');
  sortListElement();
  var gamesBox;
  for (var i in varArr)
  {
    if (!hasScroll)
    {
      if (varArr[i]['myScroll'])
      {
        varArr[i]['myScroll'].refresh();
        varArr[i]['myScroll'].scrollTo(0, 0, 0.2);
      }
    }
    else
    {
      if (!gamesBox)
        gamesBox = $(".games-box");
      gamesBox.filter('.' + i).find('div').scrollLeft('0');
    }
  }
}
function preloadBigImage() {
  if (typeof(window.arr_load) == "undefined")
    window.arr_load = [];
  var tmp;
  $('.games-box').each(function(){
    $(this).find('.icon[alt_img]').slice(0, countShowGame).each(function(){
      tmp = $(this).attr('alt_img');
      if(getPlatformFromId(tmp) == 'ipad')
      {
        if(arr_load.indexOf(tmp) == -1)
          window.arr_load.push(tmp);
      }
    });
  });
  $('.icon[alt_img]').each(function(){
    tmp = $(this).attr('alt_img');
    if(getPlatformFromId(tmp) == 'ipad')
    {
      if(arr_load.indexOf(tmp) == -1)
        window.arr_load.push(tmp);
    }
  });
  if(arr_load.length > 0){
    var img = document.createElement('img');
    $(img).bind('load', function() {
      $('div.icon[alt_img="' + arr_load[0] + '"]').removeAttr('alt_img').html('<div style="background-image:url('+ this.src + ')"></div>');
      arr_load.shift();
      if(arr_load[0])
        this.src = XPROMO_SITE + arr_load[0] + '/icon-big.jpg?' + dt;
    });
    img.src = XPROMO_SITE + arr_load[0] + '/icon-big.jpg?' + dt;
  }
}
function getBeautyBanner() {
  var prefix = '';
  var lang = lockitGetLang();
  lang = lang.toLowerCase();
  if (['de', 'es', 'fr', 'it', 'ru'].indexOf(lang) != -1)
    prefix = '_' + lang;
  var arr_tmp = [];
  var tn = $('.banners-box .banner-item');
  tn.filter('[data-img]').each(function(){
    var tmp = $(this).attr('data-img');
    if (arr_tmp.indexOf(tmp) == -1)
      arr_tmp.push(tmp);
  });
  var tmp;
  if (arr_tmp.length > 0)
  {
    for (var i in arr_tmp)
    {
      tmp = $('.banner-item[data-img="' + arr_tmp[i] + '"]').eq(0).attr('data-data');
      if (typeof tmp == 'string' && tmp.length > 0)
      {
        tmp = tmp.split('/').join('');
        tmp = '?' + tmp;
      }
      else
      {
        tmp = '';
      }
      arr_tmp[i] = [arr_tmp[i], tmp];
    }
    var img = document.createElement('img');
    $(img).bind('load', function() {
      var ths = $('.banner-item[data-img="' + arr_tmp[0][0] + '"]').removeAttr('data-img').addClass('with_image').css({
        'background-image' : 'url(' + this.src + ')'
      });
      if (!bnArr.viewed)
        ths.addClass('downloaded');
      arr_tmp.shift();
      if(arr_tmp.length > 0)
        img.src = XPROMO_SITE + arr_tmp[0][0] + '/banner' + prefix + '.jpg' + arr_tmp[0][1];
    }).bind('error', function(){
      $('.banner-item[data-img="' + arr_tmp[0][0] + '"]').removeAttr('data-img');
      arr_tmp.shift();
      if(arr_tmp.length > 0)
        img.src = XPROMO_SITE + arr_tmp[0][0] + '/banner' + prefix + '.jpg' + arr_tmp[0][1];
    });
    img.src = XPROMO_SITE + arr_tmp[0][0] + '/banner' + prefix + '.jpg' + arr_tmp[0][1];
  }
}
function myLogLP(_identificator, _tap, _location) {
  var param = [];
  param[0] = settingsOfPage.log;
  param[1] = (!!_tap)?'tap':'show';
  param[2] = _identificator;
  param[3] = _location || 'promo';
  xpromoReport("promo('" + param.join("','") + "')");
}
function setKeyBoardTv() {
  if (!ifArr['tv'].is)
    return;
  var _arr = {
    'row': 0,
    'el': [
      {'eq': 0, 'selector': '.page-header'},
      {'eq': 0, 'selector': '.select-type a'},
      {'eq': 0, 'selector': '.games-box.adv a'},
      {'eq': 0, 'selector': '.games-box.st a'},
      {'eq': 0, 'selector': '.banners-box a', 'alt_selector': '.banners-box'}
    ]
  };
  window.addEventListener('keydown', function(e){
    var _k = e.which;
    if (_k >= 37 && _k <= 40)
      e.preventDefault();
    switch (_k)
    {
      case 13:
        if (_arr['row'] == (_arr['el'].length - 1) && bnArr['status'])
          return;
        $(document.activeElement).trigger('mousedown');
        break;
      case 37:
      case 39:
        var ch = 1;
        if (_k == 37)
          ch = -1;
        if (_arr['row'] == (_arr['el'].length - 1))
        {
          nextBanner(ch);
        }
        else
        {
          var el = $(_arr['el'][_arr['row']]['selector']);
          if (el.length > 1)
          {
            _arr['el'][_arr['row']]['eq'] += ch;
            if (_arr['el'][_arr['row']]['eq'] < 0)
            {
              _arr['el'][_arr['row']]['eq'] = el.length - 1;
            }
            else
            if (_arr['el'][_arr['row']]['eq'] >= el.length)
            {
              _arr['el'][_arr['row']]['eq'] = 0;
            }
            document.activeElement.blur();
            el.eq(_arr['el'][_arr['row']]['eq']).focus();
          }
        }
        break;
      case 40:
      case 38:
        if (_arr['row'] == (_arr['el'].length - 1))
          $(_arr['el'][_arr['row']]['alt_selector']).removeClass('focused');
        var ch = 1;
        if (_k == 38)
          ch = -1;
        var el;
        do
        {
          _arr['row'] += ch;
          if (_arr['row'] < 0)
          {
            _arr['row'] = _arr['el'].length - 1;
          }
          else if (_arr['row'] >= _arr['el'].length)
          {
            _arr['row'] = 0;
          }
          el = $(_arr['el'][_arr['row']]['selector']);
        } while(el.length == 0);
        document.activeElement.blur();
        if (_arr['row'] != (_arr['el'].length - 1))
        {
          el.eq(_arr['el'][_arr['row']]['eq']).focus();
        }
        else
        {
          if (bnArr['status'] || el.length == 1)
            el.eq(bnArr.active).focus();
          $(_arr['el'][_arr['row']]['alt_selector']).addClass('focused');
        }
        break;
    }
  });
  $(_arr['el'][_arr['row']]['selector']).eq(_arr['el'][_arr['row']]['eq']).focus();
}