var activeItem = 0;
var timerID    = 1;
var myScroll   = null;
var appendLocale = {};

var mainGames = [];
var flagToStore = true;
var userAgent = navigator.userAgent.toLowerCase();
var isIpadNew = isIpadNewFunc();

var XPROMO_SITE = 'http://xpromo.g5e.com/v1/';
var bannerDir = "news";
var BANNER_SITE = XPROMO_SITE + bannerDir + '/';

var self_id = gamesSelfId();
var index = 1;

var countShowGame = 18;
var dt = new Date().getTime();

var bnArr = {'hrefFirst': '', 'cnt': 0};

var touchEvent = window.navigator.msPointerEnabled ? 'MSPointerDown' : 'touchstart';

if (!window.requestAnimationFrame)
{
  window.requestAnimationFrame = ( function() {
    return window.webkitRequestAnimationFrame ||
    window.mozRequestAnimationFrame ||
    window.oRequestAnimationFrame ||
    window.msRequestAnimationFrame ||
    function( /* function FrameRequestCallback */ callback, /* DOMElement Element */ element ) {
      window.setTimeout( callback, 1000 / 60 );
    };
  })();
}

window.onerror = function(message, source, lineno) {
  console.log("message:" + message + " source:" + source + " lineno:" + lineno);
  return false;
};

var locale = lockitRender();
mainRender();

$(document).ready(function(){
  if (/iPhone|iPod|iPad/.test(navigator.userAgent))
  {
    $('.select-type img').prependTo('.select-type a.first strong');
  }
  else
  {
    $('.select-type img').wrap('<div></div>');
    $('.select-type div').prependTo('.select-type a.first strong');
  }
  $('.game-current, .logo').on(touchEvent, function(e){
    var event = new Event('click', {bubbles: true, cancelable: true});
    e.target.dispatchEvent(event);
  });
  updateLayout();
  window.onresize = function() {
    var el = $('.select-type a.first .animate');
    el.removeClass('animate');
    updateLayout();
    el.addClass('animate');
  };
  listRender();
});

var gamesDirectiveEmpty =
{
  "li" :
  {
    "game<-games" :
    {
      "@data-id" : "game.id",
      ".icon@style" : function(arg) {
        if (arg.pos > countShowGame)
          return iconStyleFor(arg.item.id, 3);
        return 'background-image:url(' + arg.item.id + "/" + iconNameFor(arg.item.id) + ');' + iconStyleFor(arg.item.id, 3);
      },
      ".icon@alt_img" : function(arg) {
        if(isIpadNew)
          return arg.item.id;
        return '';
      }
    }
  }
};

var gamesDirective =
{
  "li" :
  {
    "game<-games" :
    {
      "a@href"      : "game.href",
      ".name"       : "game.name_short",
      ".icon@style" : function(arg) {
        return 'background-image:url(' + arg.item.id + "/" + iconNameFor(arg.item.id) + ');' + iconStyleFor(arg.item.id, 3);
      },
      ".icon@alt_img" : function(arg) {
        if(isIpadNew)
          return arg.item.id;
        return '';
      }
    }
  }
};

function mainRender()
{
  var game = gamesLoadGame(xpromoGames, self_id);
  $p(".game-current").autoRender(game,
  {
    ".name"       : "name",
    ".icon@style" : function(arg) {
      var variant = '-big';
      if(isIpadNew && getPlatformFromId(arg.context.id) == 'ipad')
        variant += '@2x';
      return "background-image: url(" + arg.context.id + "/" + iconNameFor(arg.context.id, variant) + ")" + iconStyleFor(arg.context.id, 6);
    }
  });
}

function listRender()
{
  var tmp = null,
    arr = {}, cntGenre = {'adv': 0, 'st': 0}, i, bundle;
  var cnt = parseInt(window.localStorage.getItem("xpromo.games.count"));
  if (isNaN(cnt))
    cnt = 0;
  for(i = 0; i < cnt; i++)
  {
    tmp = window.localStorage.getItem("xpromo.games." + i + ".id");
    if (tmp != null && typeof xpromoGames[tmp] != 'undefined' && tmp != self_id)
    {
      arr = $.extend({}, xpromoGames[tmp]);
      arr.id = tmp;
      if (typeof xpromoGenre == 'object')
      {
        arr.genre = 'adv';
        bundle = tmp.split('.').slice(0, 3).join('.');
        if (typeof xpromoGenre[bundle] != 'undefined')
          arr.genre = xpromoGenre[bundle].toLowerCase();
        if (['adv', 'both'].indexOf(arr.genre) != -1)
          cntGenre['adv']++;
        if (['st', 'both'].indexOf(arr.genre) != -1)
          cntGenre['st']++;
      }
      mainGames.push(arr);
    }
  }
  cntGenre['global'] = cntGenre['adv'] + cntGenre['st'];
  if (cntGenre['global'] > 0)
  {
    if (cntGenre['st'] > 0)
      $('#strategy strong').append(' <i>(' + cntGenre['st'] + ')</i>');
    if (cntGenre['adv'] > 0)
      $('#adventure strong').append(' <i>(' + cntGenre['adv'] + ')</i>');
    $('#popular strong, #recent strong').append(' <i>(' + cntGenre['global'] + ')</i>')
  }
  var gamesBox = $p(".games-box ul");
  var flag = false;
  if (typeof window['getActiveTab'] == 'function')
    index = getActiveTab('lp');
  if (index == 0)
    flag = true;
  $('.select-type a').eq(index).addClass('selected');
  var data = {'games': replaceSort(mainGames, flag)};
  countShowGame = Math.ceil(($('.games-box').width() + 1500) / 144);
  gamesBox.autoRender(data, gamesDirectiveEmpty);
  setScroll();
  var el = $('.games-box ul li');
  var mx = Math.min(el.length, countShowGame);
  for(i = 0; i < mx; i++)
    loadLi(el.eq(i));
  requestAnimationFrame(scrollGame, null);
  $('.games-box ul li[data-id]').each(function(){
    loadLi($(this), true);
  });
  setTimeout(renderGames, 1000);
}

function loadLi(_el, _flag) {
  _flag = !!_flag;
  var id = _el.attr('data-id');
  if (typeof appendLocale[id] == 'undefined')
  {
    appendLocale[id] = gamesLoadGame(xpromoGames, id);
    appendLocale[id].href = getLink(appendLocale[id]);
  }
  if (!appendLocale[id].href)
  {
    _el.remove();
  }
  else
  {
    if (_flag)
      _el.find('.icon').css('background-image','url(' + id + "/" + iconNameFor(id) + ')');
    _el.find('.name').html(appendLocale[id].name_short);
    _el.find('a').attr('href', appendLocale[id].href);
    _el.removeAttr('data-id');
  }
}

function setScroll() {
  var hasScroll = false;
  var platform = window.localStorage.getItem('xpromo.platform').toLowerCase();

  /* iPad 7_0_2 bug? correct width for iPhone version game running on the iPad(LFNII-970)   */
  if (userAgent.indexOf("7_0_2") != -1 && userAgent.indexOf("ipad") != -1 && platform == "iphone")
  {
    $('.main').width(window.innerWidth / (window.innerHeight / 768) + "px");
  }

  hasScroll |= (userAgent.indexOf("ipad") != -1 || userAgent.indexOf("iphone") != -1) &&
  (userAgent.indexOf("os 3") == -1 && userAgent.indexOf("os 4")   == -1);

  hasScroll |= (userAgent.indexOf("trident") != -1);
  if (!hasScroll)
  {
    $(".latest-games .games-box").css("overflow-x", "hidden");
    var mouseWheel = false;
    if (userAgent.indexOf("mac") != -1)
      mouseWheel = true;
    myScroll = new IScroll($p(".games-box")[0], {
      scrollX:true,
      scrollY:false,
      mouseWheel: mouseWheel,
      tap: false,
      click: true
    });
    myScroll.on('scrollEnd', function () {
      flagToStore = true;
    });

    $('.games-box').on('click', 'a', function(){
      if (flagToStore)
      {
        flagToStore = false;
        setTimeout(function(){flagToStore = true;}, 1000);
        return true;
      }
      else
      {
        return false;
      }
    });
    if (myScroll.maxScrollX < 0)
    {
      var maxScroll = Math.max(myScroll.maxScrollX, -1500);
      myScroll.scrollTo(maxScroll, 0, 0);
    }
  }
  else
  {
    var gameBox    = $('.games-box');
    var gamesBoxUl = gameBox.find('ul');
    var start      = (gamesBoxUl.width() - gameBox.width());
    start = Math.min(start, 1500);
    if (start > 0)
    {
      $(".games-box ul").css({
        'transform' : 'translate3d(-' + start + 'px, 0px, 0px)',
        '-webkit-transform' : 'translate3d(-' + start + 'px, 0px, 0px)',
        'transition' : 'transform 0s linear',
        '-webkit-transition' : '-webkit-transform 0s linear'
      });
    }
  }
}

function scrollGame() {
  setTimeout(bannerFirstRender, 0);
  var el = $('.select-type a.first div');
  if (el.length > 0)
  {
    setTimeout(function(){el.addClass('animate')},4500);
  }
  else
  {
    $('.select-type a.first img').addClass('animate');
  }
  setTimeout(function(){
    if (myScroll)
    {
      myScroll.scrollTo(0, 0, 4000);
    }
    else
    {
      var gamesBox = $('.latest-games .games-box');
      gamesBox.css({
        'overflow-scrolling': 'touch',
        '-webkit-overflow-scrolling': 'touch'
      });
      gamesBox[0].addEventListener('webkitTransitionEnd', function(e) {
        gamesBox.css({
          'overflow-scrolling': 'touch',
          '-webkit-overflow-scrolling': 'touch'
        }).find('ul').css({
          'transform': 'translate3d(0px, 0px, 0px)',
          '-webkit-transform': 'translate3d(0px, 0px, 0px)',
          'transition': 'transform 0s ease',
          '-webkit-transition': '-webkit-transform 0s ease'
        });
      }, false);
      gamesBox.find('ul').css({
        'transform': 'translate3d(0px, 0px, 0px)',
        '-webkit-transform': 'translate3d(0px, 0px, 0px)',
        'transition': 'transform 4s ease',
        '-webkit-transition': '-webkit-transform 4s ease'
      });
    }
    //setTimeout(bannersFetch, 4000);
  }, 500);
  //setTimeout(renderGames, 2000);
}

function renderGames() {
  var data = {}, i;
  var id, tmp;
  for (i in mainGames)
  {
    id = mainGames[i].id;
    if (typeof appendLocale[id] == 'undefined')
    {
      appendLocale[id] = gamesLoadGame(xpromoGames, id);
      appendLocale[id].href = getLink(appendLocale[id]);
    }
    mainGames[i] = $.extend({}, appendLocale[id]);
  }
  mainGames = mainGames.filter(function(element){
    return (!!element.href);
  });
  var gamesBox, cntGames = 0;
  var arr = {'rcnt': true, 'pplr': false};
  for (i in arr)
  {
    gamesBox = $p('.games-box-hidden ul.' + i);
    data.games = mainGames.slice(0);
    data.games = replaceSort(data.games, arr[i]);
    gamesBox.autoRender(data, gamesDirective);
  }
  arr = {'st': 'strategy', 'adv': 'adventure'};
  mainGames = replaceSort(mainGames, true);
  for (i in arr)
  {
    data.games = mainGames.filter(function(element)
    {
      if(element.genre == i || element.genre == 'both')
        return true;
      return false;
    });
    gamesBox = $p('.games-box-hidden ul.' + i);
    gamesBox.autoRender(data, gamesDirective);
    if (gamesBox[0].childElementCount > 0)
    {
      cntGames += gamesBox[0].childElementCount;
      tmp = $('#' + arr[i] + ' strong');
      if (tmp.find('i').length == 0)
      {
        tmp.append(' <i>(' + gamesBox[0].childElementCount + ')</i>');
      }
      else
      {
        tmp.find('i').html('(' + gamesBox[0].childElementCount + ')');
      }
    }
  }
  if (cntGames > 0)
  {
    tmp = $('#popular strong, #recent strong');
    if (tmp.find('i').length == 0)
    {
      tmp.append(' <i>(' + cntGames + ')</i>');
    }
    else
    {
      tmp.find('i').html('(' + cntGames + ')');
    }
  }
  function changeType(e){
    if (e.type.toLowerCase() != 'mousedown')
    {
      e.preventDefault();
      e.stopPropagation();
    }
    var th = $(this);
    var tp = th.attr('data-type');
    if (myScroll)
      myScroll.scrollTo(0, 0, 0.2);
    $('.games-box ul').html($('.games-box-hidden ul.' + tp).html());
    if (myScroll)
    {
      myScroll.refresh();
      myScroll.scrollTo(0, 0, 0);
    }
    else
    {
      $(".games-box").scrollLeft('0');
    }
    $('.select-type a').removeClass('selected');
    th.addClass('selected');
  };
  $('.select-type a').on(touchEvent, changeType).on('mousedown', changeType);
}

function getLink(_locale) {
  var ret = false;
  if (!_locale.links)
    return false;
  var arr = ['download', 'free', 'lite', 'full', 'temp'];
  for (var i in arr)
  {
    if(arr[i] in _locale.links)
    {
      if (arr[i] == 'temp')
      {
        if (mainGames.length <= 5)
        {
          ret = _locale.links[arr[i]];
          break;
        }
      }
      else
      if (_locale.date.getTime() < dt)
      {
        ret = _locale.links[arr[i]];
        break;
      }
    }
  }
  if (typeof ret == 'string')
  {
    if (ret.indexOf('javascript:') == -1)
    {
      if ('hastrk3LP' in _locale.links && _locale.links.hastrk3LP != '')
      {
        ret = convertLink("@ext(" + _locale.links.hastrk3LP + ")", "", "&sub_campaign=lp_upsell");
      }
      else
      {
        ret = convertLink("@ext(" + ret + ")", _locale.links.hastrk3, "&sub_campaign=lp_upsell");
      }
    }
  }
  return ret;
}

function updateLayout() {
  var zoom = (window.innerHeight / 768) * 100;
  document.body.style.zoom = zoom + "%";

  if (userAgent.indexOf("trident") != -1)
  {
    if (zoom>101 && zoom<101.5)
    {
      zoom = Math.round(zoom) - 1;
    }
    else
    if (zoom<100 && zoom>99.5)
    {
      zoom = Math.round(zoom) - 1;
    }

    if (zoom < Math.round(zoom))
      zoom = zoom - 1;

    zoom = Math.round(zoom);
    document.body.style.zoom = "";
    document.body.style.backgroundColor = "#31496c";
    $p(".main")[0].style.zoom = zoom + "%";
    $p(".main")[0].style.width = 100 * 100 / zoom + "%";
    $p(".banners-box")[0].style.borderTopStyle = "none";
  }
  else
  if (userAgent.indexOf("android 4") == -1)
  {
    document.body.style["font-size"] = document.body.style.zoom;
  }

  if (window.innerHeight > window.innerWidth)
  {
    $('.main').addClass('portrait-orientation');
  }
  else
  {
    $('.main').removeClass('portrait-orientation');
  }
  if (myScroll)
    myScroll.refresh();
}

function bannersFetch() {
  var bannerBase = window.localStorage.getItem("xpromo.news.base");
  if (bannerBase)
  {
    BANNER_SITE = XPROMO_SITE + bannerBase;
    if (bannerBase.indexOf('/') != -1)
      bannerDir = bannerBase.slice(0, bannerBase.indexOf('/'));
    else
      bannerDir = bannerBase;
  }
  var bannerRequest = new XMLHttpRequest();
  bannerRequest.open("GET", BANNER_SITE + "banners.txt", true);
  bannerRequest.onreadystatechange = function(){
    if (this.readyState != 4)
      return;

    var text;
    if (this.status == 200 || this.responseText) // for local GET to work
    {
      text = this.responseText;
      getBanners(JSON.parse(text));
    }
    else
    {
      var t = document.createElement("script");
      t.src = XPROMO_SITE + 'service/get_banners.php?bannerDir=' + bannerDir + "&bannerFile=banners.txt&functionName=getBanners";
      t.onerror = function(){
        getBanners(getBannersFromStorage());
      };

      document.body.appendChild(t);
    }
  };
  bannerRequest.send(null);
}

function getBannersFromStorage() {
  var content = window.localStorage.getItem('xpromo.banners');
  if (content != null)
    return JSON.parse(content);
  return lockitLoadLangs(bannerDir + '/banners');
}

function getBanners(text, _flag) {
  _flag = !_flag;
  if (_flag)
    window.localStorage.setItem("xpromo.banners", JSON.stringify(text));
  $('.banners-box').css('overflow', 'visible');
  var xpromoBanners = null;
  if (text)
    xpromoBanners = lockitGet(text);
  //xpromoBanners = lockitGet(JSON.parse(text));

  var data = {};
  data.banners = locale.banners;
  if (xpromoBanners)
    data.banners = xpromoBanners.banners.concat(data.banners);

  var timeNow = new Date().getTime();

  data.banners = data.banners.filter(function(element, index, array)
  {
    if (element.begsAt)
    {
      var begsAt = new Date(element.begsAt);
      if (timeNow < begsAt.getTime())
        return false;
    }

    if (element.endsAt)
    {
      var endsAt = new Date(element.endsAt);
      if (timeNow >= endsAt.getTime())
        return false;
    }

    if (element.includes)
    {
      var arrIncludes = element.includes.split('|');
      if(!inArray(self_id, arrIncludes))
        return false;
    }

    if (element.excludes)
    {
      var arrExcludes = element.excludes.split('|');
      if(inArray(self_id, arrExcludes) != false)
        return false;
    }

    if(element.hastrk3LP != undefined && element.hastrk3LP != "")
    {
      element.href = convertLink(element.hastrk3LP, "", "&sub_campaign=lp_promo");
    }
    else
    {
      element.href = convertLink(element.href, element.hastrk3, "&sub_campaign=lp_promo");
    }

    return true;
  });
  if (_flag)
    bannersRender(data);
  //timerID = setTimeout('scrollerByTimeOut()', 7000);
  return data;
}

var bannerDirective = {
  "@id" : function(arg) {
    return "banner-item-" + (arg.context.pos + 1);
  },
  "@href" : "href",
  "@data-xpromoid"  : function(arg) {
    if (arg.context.icon)
      return arg.context.icon.split('/')[0];
    else
    if (arg.context.style)
      return arg.context.style.split('/')[1].split('.')[0] + ".png";
    else
      return "else.lp";
  },
  "@style" : function(arg) {
    var result = "";
    if (arg.context.pos != 0)
      result += "display:none;";
    if (arg.context.style)
      result += arg.context.style;
    return result;
  },
  ".icon@style" : function(arg) {
    if (arg.context.icon)
    {
      var tmp = arg.context.icon;
      var pos = tmp.indexOf('/');
      if(pos != -1)
      {
        tmp = tmp.substring(0, pos);
        var platform = '';
        var img = 'icon.jpg';
        for (var i in mainGames)
        {
          if (mainGames[i]['id'] == tmp)
          {
            platform = getPlatformFromId(mainGames[i]['id']);
            if (platform == 'mac')
              img = 'icon.png';
            return "background-image: url('" + mainGames[i]['id'] + "/" + img + "')" + iconStyleFor(mainGames[i]['id'], 3);
          }
        }
        var bundle = tmp.split('.');
        bundle = bundle[2];
        for (var i in mainGames)
        {
          tmp = mainGames[i]['id'].split('.');
          tmp = tmp[2];
          if (bundle == tmp)
          {
            platform = getPlatformFromId(mainGames[i]['id']);
            if (platform == 'mac')
              img = 'icon.png';
            return "background-image: url('" + mainGames[i]['id'] + "/" + img + "')" + iconStyleFor(mainGames[i]['id'], 3);
          }
        }
        tmp = arg.context.icon.substring(0, pos);
        return "background-image: url('" + XPROMO_SITE + arg.context.icon + "')" + iconStyleFor(tmp, 3);
      }
    }
    return "display:none;";
  },
  ".icon@alt_img" : function(arg) {
    if (arg.context.icon && isIpadNew)
    {
      var tmp = arg.context.icon;
      var pos = tmp.indexOf('/');
      if(pos != -1)
        return tmp.substring(0, pos);
    }
    return '';
  },
  ".icon@class"     : function(arg) {
    if (arg.context.icon)
    {
      var game_id = arg.context.icon;
      game_id = game_id.split('/');
      game_id = game_id[0];
      var platform = getPlatformFromId(game_id);
      return "icon icon_" + platform;
    }
    return "icon";
  },
  "div.text" : "text",
  "@data-img" : function(arg) {
    if (arg.context.style)
    {
      var tmp = arg.context.style;
      var needle = 'url(';
      var pos = tmp.indexOf(needle);
      if (pos > -1)
      {
        tmp = tmp.substr(pos + needle.length);
        pos = tmp.indexOf(')');
        if (pos > -1)
        {
          tmp = tmp.substr(0, pos);
          tmp = tmp.replace(/\'/g, '');
          tmp = tmp.replace(/\"/g, '');
          tmp = tmp.split('.');
          tmp[tmp.length - 2] += '_win';
          return tmp.join('.');
        }
      }
    }
    return '';
  },
  ".+" : function(arg) {
    return arg.context.button ? ("<div class='button'><span>" + arg.context.button + "</span></div>") : "";
  }
};

function bannerFirstRender () {
  var bannerBase = window.localStorage.getItem("xpromo.news.base");
  if (bannerBase)
  {
    bannerBase = bannerBase.split('/');
    bannerDir = bannerBase[0];
  }
  bnArr.bannerBox = $('.banners-box');
  bnArr.hiddenBox = $('.hidden-box');
  bnArr.hiddenBox.html(bnArr.bannerBox.html());
  bnArr.compiled = bnArr.hiddenBox.find('.banner-item').compile(bannerDirective);
  var content = '';
  var _data = getBannersFromStorage();
  if (typeof _data == 'object')
  {
    _data = getBanners(_data, true);
    if (_data.banners.length > 0)
    {
      _data.banners[0].pos = bnArr.cnt;
      bnArr.cnt++;
      bnArr.hrefFirst = _data.banners[0].href;
      content = bnArr.compiled(_data.banners[0]);
      bnArr.bannerBox.html(content);
      //fixBanner();
    }
  }
  setTimeout(bannersFetch, 4000);
}
function bannersRender(_data) {
  if (bnArr.cnt == 0)
  {
    bnArr.bannerBox.html('');
    //fixBanner();
  }
  else
  {
    _data.banners = _data.banners.filter(function (element) {
      if (element.href == bnArr.hrefFirst)
        return false;
      return true;
    });
  }
  var content = '';
  for (var i in _data.banners)
  {
    _data.banners[i].pos = bnArr.cnt;
    bnArr.cnt++;
    content = bnArr.compiled(_data.banners[i]);
    bnArr.bannerBox.append(content);
  }
  timerID = setTimeout('scrollerByTimeOut()', 3000);
  if(isIpadNew)
    preloadBigImage();
  if (userAgent.indexOf("trident") != -1)
    bannerWin();
}

function fixBanner() {
  if (/iPhone|iPod|iPad/.test(navigator.userAgent)) {
    var el = document.createElement('iframe');
    el.style.marginTop = "10px";
    el.style.display = "none";
    el.src = 'theme/let.png';
    document.body.appendChild(el);
    setTimeout(function () {
      el.parentNode.removeChild(el);
    }, 500);
  }
}

function scrollerByTimeOut()
{
  clearTimeout(timerID);
  var nextItem = activeItem + 1;
  var el = $('.banners-box .banner-item');
  if (nextItem >= el.length)
    nextItem = 0;
  if (nextItem != activeItem)
  {
    el.eq(activeItem).fadeOut(500);
    el.eq(nextItem).fadeIn(500);
    activeItem = nextItem;
  }
  timerID = setTimeout('scrollerByTimeOut()', 10000);
}
function preloadBigImage() {
  if (typeof(window.arr_load) == "undefined")
    window.arr_load = [];
  var tmp;
  var dt = '?v=' + (new Date().getTime());
  $('.icon').each(function(){
    tmp = $(this).attr('alt_img');
    if(getPlatformFromId(tmp) == 'ipad')
    {
      if(!inArray(tmp, arr_load))
        window.arr_load.push(tmp);
    }
  });
  if(arr_load.length > 0){
    var img = document.createElement('img');
    $(img).bind('load', function() {
      $('div.icon[alt_img="' + arr_load[0] + '"]').removeAttr('alt_img').html('<div style="background-image:url('+ XPROMO_SITE + arr_load[0] + '/icon-big.jpg?' + dt + ')"></div>');
      $('img.icon[alt_img="' + arr_load[0] + '"]').attr('src', XPROMO_SITE + arr_load[0] + '/icon-big.jpg' + dt).removeAttr('alt_img');
      arr_load.shift();
      if(arr_load[0])
        img.src = XPROMO_SITE + arr_load[0] + '/icon-big.jpg' + dt;
    });
    img.src = XPROMO_SITE + arr_load[0] + '/icon-big.jpg' + dt;
  }
}
function bannerWin() {
  var allA = $('.banners-box a');
  var arr = [];
  var el, i;
  for (i = 0; i < allA.length; i++)
  {
    el = allA.eq(i);
    if (el.attr('data-img'))
      arr.push(el.attr('data-img'));
  }
  if (arr.length > 0)
  {
    function setWinBanner(_name) {
      var image = new Image();
      image.onload = function() {
        allA.filter("[data-img='" + _name + "']").each(function() {
          $(this).css('background-image', 'none').find('div.icon').css('background-image', 'url(' + _name + ')').addClass('icon_mac').show();
        });
      }
      image.src = _name;
    }
    for (i in arr)
      setWinBanner(arr[i]);
  }
}
