if (!window.requestAnimationFrame)
{
  window.requestAnimationFrame = ( function() {
    return window.webkitRequestAnimationFrame ||
    window.mozRequestAnimationFrame ||
    window.oRequestAnimationFrame ||
    window.msRequestAnimationFrame ||
    function( /* function FrameRequestCallback */ callback, /* DOMElement Element */ element ) {
      window.setTimeout( callback, 1000 / 60 );
    };
  })();
}

var lockitLang = 'en';
var lockitCache = {};

function loadDefault(_name, _callback, _path) {
  _path = _path|| '';
  if (window.localStorage.getItem("xpromo") == null || window.localStorage.getItem("xpromo") == "test")
  {
    $.getJSON(_path + 'scripts/default.json', function(_json) {
      if (typeof _json[_name] == 'object')
      {
        window.localStorage.clear();
        window.localStorage.setItem("xpromo", "test");
        for (var i in _json[_name])
          window.localStorage.setItem("xpromo." + i, _json[_name][i]);
      }
      _callback();
    });
  }
  else
  {
    _callback();
  }
}

function lockitLoadLangs(_title, _callback, _flag) {
  if (_title in lockitCache)
  {
    _callback(lockitCache[_title]);
  }
  else
  {
    if (!!_flag)
      lockitCache[_title] = null;
    $.ajax({
      dataType: "json",
      url: _title + '.txt',
      data: null,
      success: function (_json) {
        lockitCache[_title] = _json;
        _callback(_json);
      },
      error: function () {
        _callback(null);
      }
    });
  }
}

function lockitRenderData(_data) {
  if (typeof _data == 'object')
    _data = lockitGet(_data);
  if (_data)
  {
    for (var sel in _data)
      $(sel).each(function(){$(this).html(_data[sel]);});
  }
  return _data;
}

function lockitGet(_data) {
  if (_data)
  {
    var english = _data["lang.en"];
    var lang    = lockitLang;
    var result  = _data["lang." + lang];

    if (!result)
    {
      result = english;
      lang   = "en";
    }
    else
    if (result != english)
    {
      for (var k in english)
        if (!result.hasOwnProperty(k))
          result[k] = english[k];
    }

    if (result)
      result.lang = lang;

    return result;
  }

  return null;
}

function lockitGetLang() {
  var lang = (match = window.location.search.match(new RegExp("[?|&]?" + 'lang' + "=([^&]*)"))) ? match[1] : null;
  if (!lang)
    lang = window.localStorage.getItem("xpromo.lang");
  if (!lang)
  {
    if (navigator.userLanguage)
      lang = navigator.userLanguage;
    else
    if (navigator.language)
      lang = navigator.language.split("-")[0];
  }
  if (!lang)
    lang = lockitLang;
  window.localStorage.setItem("xpromo.lang", lang);
  return lang;
}

function gamesSelfId() {
  var result = window.localStorage.getItem("xpromo.games.self.id");
  if (null == result)
    result = window.localStorage.getItem("xpromo.id");
  return result;
}

function getPlatformFromId(id)
{
  var arrPlatform = {
    'android': 'android',
    'hd': 'ipad',
    'mac': 'mac',
    'pc': 'pc',
    'winrt': 'winrt',
    'winphone': 'winphone'
  };
  var arrBundle = id.split('.');
  for (var i in arrPlatform)
  {
    if (arrBundle.indexOf(i) != -1)
      return arrPlatform[i];
  }
  return 'iphone';
}